<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Auth extends Backend_Controller {
	
	function __construct()
	{
		parent::__construct();
	}
	
	function index() 
	{
		$this->user_mdl->loggedin() == FALSE || redirect('dashboard');
		$this->data['loginpage']  = TRUE;
		$this->data['subview'] = 'login/login';
		$this->load->view('login/_layout', $this->data);
	}
	
	function login()
	{
		$rules = $this->user_mdl->login_rules;
		$this->form_validation->set_rules($rules);
	
		if($this->form_validation->run())
		{
			if($this->user_mdl->login() == TRUE){
				$response = array(
					'success'           => 1,
					'group'				=> $this->session->userdata('user_group')
					);
			}
			else {
				$this->session->set_flashdata('error', 'That email/password combination does not exist');
				$response = array(
						'success'           => 0,
						'login_fail'		=> true,
						'login_error'		=> 'Wrong email/password combination, please try again',
				);
			}
		}
		else
		{
			$this->load->helper('json_error');
			$response = array(
					'success'           => 0,
					'validation_errors' => json_errors()
			);
				
		}
		echo json_encode($response);
	}
	function reset_password(){
		if(!empty($_POST)){
			$rules = $this->user_mdl->password_reset_rules;
			$this->form_validation->set_rules($rules);
			$this->form_validation->set_error_delimiters('<p class="has-error"><label class="control-label">', '</label></p>');
			if($this->form_validation->run())
			{
			   $email = $this->input->post('email');
			   $this->db->where('email', $email);
			   $email_exists = $this->user_mdl->get(null, true);
			  if(!empty($email_exists)) : 
			  	$new_password = $this->create_guid();
			  	$password_details = array('password' => $this->user_mdl->hash($new_password));
			  	$this->user_mdl->save($password_details, $email_exists->id);
			  	$this->notifications->password_reset($email_exists, $new_password);
			  	$this->session->set_flashdata('success', 'Password reset successful, please check your email for the new password');
			  	redirect('auth/reset_password');
			  else : 
			  	$this->session->set_flashdata('error', 'That email does not exist');
			    redirect('auth/reset_password');
			  endif;
			}
		}
		$this->data['loginpage']  = TRUE;
		$this->data['subview'] = 'login/reset_password';
		$this->load->view('login/_layout', $this->data);
	}
	
	function logout()
	{	
		$this->user_mdl->logout();
		redirect('auth');
	}
	
	public function create_guid()
	{
		$pwd = str_shuffle('abcefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890');
		$guid = urlencode(substr($pwd,0,8));
		return $guid;
	}
}