<?php
class Cdashboard extends Frontend_Controller {
	protected  $client_id = 0;
	function __construct() 
	{
		parent::__construct();
		$this->data['_menu'] = 'dashboard'; 
		$this->client_id = get_client_id();
	}
	
	function index() 
	{
		$this->load->model('project_mdl');
		$this->load->model('invoice_mdl');
		$this->load->model('tickets_mdl');
		$this->load->model('payment_mdl');
		/*---------------------------------------------------------------------------------------------------------
		 | Get the project details
		|----------------------------------------------------------------------------------------------------------*/
		$projects = new stdClass ();
		$this->db->where('client_id', $this->client_id);
		$this->db->where('project_status', 'closed');
		$projects_data = count($this->project_mdl->get());
		$projects->closed_projects = $projects_data;
		$this->db->where('client_id', $this->client_id);
		$projects->total_projects = count($this->project_mdl->get());
		$this->data['projects'] = $projects;
		/*---------------------------------------------------------------------------------------------------------
		 | Get all the invoices created
		|----------------------------------------------------------------------------------------------------------*/
		$this->db->where('invoice_status !=', 'DRAFT');
		$this->db->where('client_id', $this->client_id);
		$this->data['total_invoices'] = count($this->invoice_mdl->get());
		/*---------------------------------------------------------------------------------------------------------
		 | Get all the tickets details
		|----------------------------------------------------------------------------------------------------------*/
		$this->db->where('client_id', $this->client_id);
		$this->data['all_tickets'] =  count($this->tickets_mdl->get());
		$this->db->where('client_id', $this->client_id);
		$this->db->where('ticket_status', 'closed');
		$this->data['closed_tickets'] =  count($this->tickets_mdl->get());
		/*---------------------------------------------------------------------------------------------------------
		 | Get total paid amount
		|----------------------------------------------------------------------------------------------------------*/
		$this->db->select_sum('payments.payment_amount', 'paid_amount');
		$this->db->where('invoice_status !=', 'DRAFT');
		$this->db->where('invoices.client_id', $this->client_id);
		$this->db->join('payments', 'payments.invoice_id = invoices.invoice_id');
		$this->data['total_paid'] = format_amount($this->invoice_mdl->get(null, true)->paid_amount, true);
		/*---------------------------------------------------------------------------------------------------------
		 | Get all the latest invoices created
		|----------------------------------------------------------------------------------------------------------*/
		$this->db->where('invoices.client_id', $this->client_id);
		$this->db->where('invoice_status !=', 'DRAFT');
		$this->db->join('projects', 'projects.project_id = invoices.project_id', 'LEFT');
		$this->db->limit(10);
		$this->data['latest_invoices'] = $this->invoice_mdl->get();
		/*---------------------------------------------------------------------------------------------------------
		 | Get all the latest payments details
		|----------------------------------------------------------------------------------------------------------*/
		$this->data['latest_payments'] =  array();

		$this->data['pagecontent'] = 'frontend/dashboard';
		$this->load->view('components/_layout', $this->data);
	}
}