<?php
class Clients extends Backend_Controller {
	
	function __construct() 
	{
		parent::__construct();
		$this->load->model('client_mdl');
		$this->data['_menu'] = 'clients';
	}
	function index()
	{
		//Get clients from the database
		$count = $this->db->count_all_results('clients');
		// Set pagination
		$perpage = $this->pagination_config['per_page'];
		if ($count > $perpage) {
			$this->pagination_config['base_url'] = site_url($this->uri->segment(1) .'/index/');
			$this->pagination_config['total_rows'] = $count;
			$this->pagination_config['uri_segment'] = 3;
			$this->pagination->initialize($this->pagination_config);
			$this->data['pagination'] = $this->pagination->create_links();
			$offset = $this->uri->segment(3);
		}
		else{
			$this->data['pagination'] = '';
			$offset = 0;
		}
		$this->db->limit($perpage, $offset);
		$this->data['offset'] = $offset + 1;
		$this->data['clients'] = $this->client_mdl->get();
		$this->data['pagecontent'] = 'clients/list_clients';
		
		if(IS_AJAX)
			$this->load->view('clients/list_clients', $this->data);
		else
			$this->load->view('components/_layout', $this->data);
	}
	function client_form($id = null){
		if($id){
			$this->data['client'] = $this->client_mdl->get($id);
			count($this->data['client']) || $this->data['errors'][] = 'Client could not be found';
		}
		else {
			$this->data['client'] = $this->client_mdl->get_new();
		}
		$this->data['pagecontent'] = 'clients/client_form';
		$this->load->view('components/_layout', $this->data);
	}
	
	function save(){
		$id = ($this->input->post('client_id') != '') ? $this->input->post('client_id') : null;
		$client_user_id = ($this->input->post('client_user_id') != '') ? $this->input->post('client_user_id') : null;
		
		$rules = $this->client_mdl->register_rules;
		if(!$id){ $rules['password']['rules'] .= '|required';  $rules['cpassword']['rules'] .= '|required';};
		
		$this->form_validation->set_rules($rules);
		if($this->form_validation->run())
		{
			$post_fields = array('firstname', 'lastname', 'email', 'address', 'company', 'city', 'country', 'hourly_rate');
			$user_account_fields = array('firstname', 'lastname', 'email', 'password');
			
			$account_data = $this->client_mdl->array_from_post($post_fields);
			$user_account_data = $this->client_mdl->array_from_post($user_account_fields);
			
			$user_notification = new stdClass();
			$user_notification->username = $this->input->post('firstname');
			$user_notification->password = $this->input->post('password');
			$user_notification->email = $this->input->post('email');
			
			
			if($user_account_data['password'] != ''){
				$user_account_data['password'] = $this->user_mdl->hash($user_account_data['password']);
			}
			else {
				unset($user_account_data['password']);
			}
				$user_account_data['user_group'] = 3;
				$user_id = $this->user_mdl->save($user_account_data, $client_user_id);
				$account_data['uacc_fk']	=	$user_id;
				$client_id = $this->client_mdl->save($account_data, $id);
				
				//Send user login details via email
				if($id == null)
					$this->notifications->login_details($user_notification);
				
				$response = array('success' => 1);
				$this->session->set_flashdata('success', 'client details saved successfully');
		}
		else
		{
			$response = array(
					'success'           => 0,
					'validation_errors' => json_errors()
			);
		
		}
		echo json_encode($response);
	}
	
	public function _unique_email($str){
	
		//DO NOT validate if email exists
		//UNLESS it the email for the current user
	
		$id = $this->uri->segment(3);
		$this->db->where('email', $this->input->post('email'));
		!$id || $this->db->where('client_id != ', $id);
		$user = $this->client_mdl->get();
	
		if(count($user)){
			$this->form_validation->set_message('_unique_email', '%s should be unique');
			return FALSE;
		}
		return TRUE;
	}
	
	public function delete($client_id = null){
		//delete the users profile picture
		$this->db->join('users', 'users.id = clients.uacc_fk');
		$client = $this->client_mdl->get($client_id, true);
		$profile_picture = $client->profile_pic;
		delete_profile_pic($profile_picture);
		
		//delete the user
		$this->client_mdl->delete_client($client_id);	
		$this->session->set_flashdata('success', 'Client has been deleted !!');
		redirect('clients');
	}
}