<?php
class Cprojects extends Frontend_Controller {
	protected  $client_id = 0;
	function __construct() 
	{
		parent::__construct();
		$this->data['_menu'] = 'projects'; 
		$this->load->model('project_mdl');
		$this->client_id = get_client_id();
	}
	
	public function index(){
		//Get projects from the database
		$this->db->where('client_id', $this->client_id);
		$count = $this->db->count_all_results('projects');
		// Set pagination
		$perpage = $this->pagination_config['per_page'];
		if ($count > $perpage) {
			$this->pagination_config['base_url'] = site_url($this->uri->segment(1) .'/index/');
			$this->pagination_config['total_rows'] = $count;
			$this->pagination_config['uri_segment'] = 3;
			$this->pagination->initialize($this->pagination_config);
			$this->data['pagination'] = $this->pagination->create_links();
			$offset = $this->uri->segment(3);
		}
		else{
			$this->data['pagination'] = '';
			$offset = 0;
		}
		$this->db->where('projects.client_id', $this->client_id);
		$this->db->limit($perpage, $offset);
		$this->db->join('clients', 'clients.client_id = projects.client_id', 'LEFT');
		$this->data['projects'] = $this->project_mdl->get();
		$this->data['pagecontent'] = 'frontend/projects';
		if(IS_AJAX)
			$this->load->view('frontend/projects', $this->data);
		else
			$this->load->view('components/_layout', $this->data);
	}
	
	public function view($project_id = null){
		$this->db->join('clients', 'clients.client_id = projects.client_id', 'LEFT');
		$this->data['project'] = $this->project_mdl->get($project_id, true);
		$this->data['pagecontent'] = 'frontend/viewproject';
		$this->load->view('components/_layout', $this->data);
	}
}