<?php
class Ctickets extends Frontend_Controller {
	protected  $client_id = 0;
	function __construct() 
	{
		parent::__construct();
		$this->data['_menu'] = 'tickets';
		$this->load->model('tickets_mdl');
		$this->client_id = get_client_id();
	}
	
	public function index($filter = 'all'){
		//Get clients from the database
		$this->db->where('tickets.client_id', $this->client_id);
		$count = count($this->tickets_mdl->get_tickets($filter));

		// Set pagination
		$perpage = $this->pagination_config['per_page'];
		if ($count > $perpage) {
			$this->pagination_config['base_url'] = site_url($this->uri->segment(1) .'/index/'.$filter.'/');
			$this->pagination_config['total_rows'] = $count;
			$this->pagination_config['uri_segment'] = 4;
			$this->pagination->initialize($this->pagination_config);
			$this->data['pagination'] = $this->pagination->create_links();
			$offset = $this->uri->segment(4);
		}
		else{
			$this->data['pagination'] = '';
			$offset = 0;
		}
		$this->db->where('tickets.client_id', $this->client_id);
		$this->db->limit($perpage, $offset);
		$this->data['tickets'] = $this->tickets_mdl->get_tickets($filter);
		$this->data['filter_by'] = $filter;
		$this->data['client_id'] = $this->client_id;
		
		$this->data['pagecontent'] = 'frontend/tickets';
		
		if(IS_AJAX)
			$this->load->view('frontend/tickets', $this->data);
		else
			$this->load->view('components/_layout', $this->data);
	}
	
	public function view($ticket_id = null){
		$this->db->where('tickets.client_id', $this->client_id);
		$this->data['ticket'] = $this->tickets_mdl->view_ticket($ticket_id);
		$this->data['pagecontent'] = 'frontend/view_ticket';
		$this->load->view('components/_layout', $this->data);
	}
}