<?php
class Dashboard extends Backend_Controller {
	function __construct() 
	{
		parent::__construct();
		$this->data['_menu'] = 'dashboard'; 
	}
	
	function index() 
	{
		$this->load->model('project_mdl');
		$this->load->model('invoice_mdl');
		$this->load->model('timer_mdl');
		$this->load->model('payment_mdl');
		$this->data['projects_select'] = $this->project_mdl->projects_dropdown();
		$this->data['latest_entries'] = $this->timer_mdl->latest_entries();
		/*---------------------------------------------------------------------------------------------------------
		 | Get the project details
		|----------------------------------------------------------------------------------------------------------*/
		$projects = new stdClass ();
		$this->db->where('project_status', 'closed');
		$projects_data = count($this->project_mdl->get());
		$projects->closed_projects = $projects_data;
		$projects->total_projects = count($this->project_mdl->get());
		$this->data['projects'] = $projects;
		/*---------------------------------------------------------------------------------------------------------
		 | Get hours worked
		|----------------------------------------------------------------------------------------------------------*/
		$this->data['total_hours_clocked'] = $this->timer_mdl->total_hours_clocked();
		/*---------------------------------------------------------------------------------------------------------
		 | Get total amount received
		|----------------------------------------------------------------------------------------------------------*/
		$this->db->select_sum('payment_amount', 'total_earnings');
		$earnings = $this->payment_mdl->get(null, true);
		$this->data['total_received'] = format_amount($earnings->total_earnings, true);
		/*---------------------------------------------------------------------------------------------------------
		 | Get all the invoices created
		|----------------------------------------------------------------------------------------------------------*/
		$this->data['total_invoices'] = count($this->invoice_mdl->get());
		$this->data['this_week_hrs'] = $this->timer_mdl->this_week_hours();
		$this->data['pagecontent'] = 'dashboard/dashboard';
		$this->load->view('components/_layout', $this->data);
	}
	
	function parse()
	{
		$this->load->model('templates_mdl');
		$template = $this->templates_mdl->get(1, true);
		
		$logo = show_logo();
		
		$data = array('username' => 'samkaranja',
					  'ticket_number' => '24353453453sfdsfsdf',
					  'ticket_date' => '13/1/2014',
					  'ticket_message' => 'I have updated the system as you requested',
					  'company' => 'LLC Twigahost Web Solutions',
					  'company_logo' => show_logo()
		);
		$this->load->library('email_notifications');
		$body = $this->email_notifications->send_notification($template->body, $data, 'sammkaranja@gmail.com', $template->subject);
	}
}