<?php
class Notifications extends Frontend_Controller {
	function __construct() 
	{
		parent::__construct();
		$this->data['_menu'] = '';
		$this->load->model('notifications_mdl');
	}
	public function index(){
		$logged_user = $this->session->userdata('id');
		$this->db->where('to_user', $logged_user);
		$this->db->where('seen', '0');
		$unread_notification = count($this->notifications_mdl->get());
		$notification_stack = array();
		if($unread_notification > $this->input->post('notification_count')){
			$this->db->where('to_user', $logged_user);
			$this->db->where('seen', '0');
			$unread_notifications = $this->notifications_mdl->get();
			foreach ($unread_notifications as $count=>$notification) : 
				$notification_stack[$count] = '<li>
                            	<a href="' . site_url($notification->notification_link) . '" alt="'.$notification->notification_id.'" class="view_notification">
                                <div>
                                    <strong>' . $notification->subject . '</strong>
                                    <span class="pull-right text-muted">
                                        <em> ' . timeDiff($notification->timestamp) . ' </em>
                                    </span>
                                </div>
                                <div>' . $notification->notification_content . '</div>
                            </a>
                        </li><li class="divider"></li>';
			endforeach;
			
		}
		$unread_count = $unread_notification - $this->input->post('notification_count');
		
		$response = array('success' => true, 'notification_count' => $unread_count, 'data'=> $notification_stack);
		echo json_encode($response);
	}
	public function mark_as_read(){
		$notification_id = $this->input->post('notification_id');
		$data = array('seen' => 1);
		$this->notifications_mdl->save($data, $notification_id);
		$response = array('success' => true);
		echo json_encode($response);
	}
}