<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Payments extends Backend_Controller {
	
	function __construct()
	{
		parent::__construct();
		$this->load->model('payment_mdl');
		$this->load->model('invoice_mdl');
	}
	
/*---------------------------------------------------------------------------------------------------------
 | Function to enter invoice payments to the database
|----------------------------------------------------------------------------------------------------------*/
	public function enter_payment(){
		$invoice_id = ($this->input->post('invoice_id') != '') ? $this->input->post('invoice_id') : null;
		$rules = $this->payment_mdl->payment_rules;
		$this->form_validation->set_rules($rules);
		if($this->form_validation->run())
		{
			$post_fields = array('payment_date', 'payment_amount', 'payment_method', 'payment_note', 'invoice_id');				
			$payment_data = $this->payment_mdl->array_from_post($post_fields);
			$this->payment_mdl->save($payment_data);
			$this->invoice_mdl->set_invoice_status($invoice_id);
			$response = array('success' => 1);
			$this->session->set_flashdata('success', 'Payment saved successfully');
		}
		else{
			$response = array('success' => 0, 'validation_errors' => json_errors());
		}
		echo json_encode($response);
	}
	
	
}