<?php
class Settings extends Backend_Controller {
	
	function __construct() 
	{
		parent::__construct();
		$this->load->model('settings_mdl');
		$this->data['_menu'] = 'settings';
	}
	
	function index() 
	{
		$settings = $this->settings_mdl->get(null, true);
		$id = (!empty($settings->id)) ? $settings->id : null;
		
		if(!empty($_POST)){
			$rules = $this->settings_mdl->settings_rules;
			$this->form_validation->set_rules($rules);
			if($this->form_validation->run())
			{
				$post_fields = array('company_name',
									 'address', 
									 'city', 
									 'phone', 
									 'email', 
									 'tax', 
						             'currency', 
									 'date_format', 
									 'decimal_places', 
									 'decimal_separator', 
									 'thousand_separator',
									 'time_format',
									 'website',
									 'invoice_due_days');
				$settings_data = $this->settings_mdl->array_from_post($post_fields);
				
				if((isset($_FILES['company_logo']) && $_FILES['company_logo']['name'] != '') || (isset($_FILES['invoice_logo']) && $_FILES['invoice_logo']['name'] != ''))
				{
					$company_logo_fail_error = '';
					$invoice_logo_fail_error = '';
					
					if($_FILES['invoice_logo']['name'] != ''){
	
					 	$invoice_logo_upload_response = $this->upload_logo('invoice_logo');
					 	// Validate the invoice logo upload
					 	if($invoice_logo_upload_response['success'])
					 	{
					 		$upload_data = $invoice_logo_upload_response['upload_data'];
					 		$settings_data['invoice_logo'] = $upload_data['file_name'];
					 	}
					 	else {
					 		$invoice_logo_fail_error = $invoice_logo_upload_response['msg'];
					 		$this->data['errors']['invoice_logo'] = $invoice_logo_upload_response['msg'];
					 	}
					}
					
					if($_FILES['company_logo']['name'] != ''){
						$company_logo_upload_response = $this->upload_logo('company_logo');
						// Validate the company logo upload
						if($company_logo_upload_response['success'])
						{
							$upload_data = $company_logo_upload_response['upload_data'];
							$settings_data['company_logo'] = $upload_data['file_name'];
						}
						else{
							$company_logo_fail_error = $company_logo_upload_response['msg'];
							$this->data['errors']['company_logo'] = $company_logo_upload_response['msg'];
						}
					}
					
					if($company_logo_fail_error == '' && $invoice_logo_fail_error == ''){
						// save the records in the database and delete previous logo
						$settings = $this->settings_mdl->get(null, true);
						$this->settings_mdl->save($settings_data, $id);
						if(isset($settings_data['company_logo']))
						{
							if(!empty($settings->company_logo))
							{
								if(is_file(UPLOADSFOLDER.$settings->company_logo))
									unlink(UPLOADSFOLDER.$settings->company_logo);
							}
						}
						
						//delete previous invoice logo
						if(isset($settings_data['invoice_logo']))
						{
							if(!empty($settings->invoice_logo))
							{
								if(is_file(UPLOADSFOLDER.$settings->invoice_logo))
									unlink(UPLOADSFOLDER.$settings->invoice_logo);
							}
						}
						
						$response = array('success' => 1);
						$this->session->set_flashdata('success', 'settings saved successfully');
					}
					else
					{
						$response = array(
								'success'           => 0,
								'invalid_upload'	=> true,
								'company_logo_fail_error' => $company_logo_fail_error,
								'invoice_logo_fail_error' => $invoice_logo_fail_error,
								'validation_errors' => json_errors()
						);
					}
				}
				else
				{
					$this->settings_mdl->save($settings_data, $id);
					$response = array('success' => 1);
					$this->session->set_flashdata('success', 'settings saved successfully');
				}
			}
			else
			{
				$response = array(
						'success'           => 0,
						'validation_errors' => json_errors()
				);
			}
		}
		//Fetch settings record or set a new one
		if($id){
			$this->data['settings'] = $this->settings_mdl->get($id);
			count($this->data['settings']) || $this->data['errors'][] = 'Settings could not be found';
		}
		else {
			$this->data['settings'] = $this->settings_mdl->get_new();
		}
		
		if(!IS_AJAX){
		$this->data['pagecontent'] = 'settings/system_settings';
		$this->load->view('components/_layout', $this->data);
		}
		else
		{
			echo json_encode($response);
		}
	}

	public function paypal(){
		$this->load->model('paypal_mdl');
		$settings = $this->paypal_mdl->get(null, true);
		$id = (!empty($settings->id)) ? $settings->id : null;
		
		if(!empty($_POST)){
			$rules = $this->paypal_mdl->settings_rules;
			$this->form_validation->set_rules($rules);
			if($this->form_validation->run())
			{
				$post_fields = array('paypal_account',
									'paypal_currency',
									'paypal_ipn',
									'active',
									);						
				$settings_data = $this->paypal_mdl->array_from_post($post_fields);
				$this->paypal_mdl->save($settings_data, $id);
				$response = array('success' => 1);
				$this->session->set_flashdata('success', 'settings saved successfully');
			}
			else{
				$response = array(
						'success'           => 0,
						'validation_errors' => json_errors()
				);
			}
		 }
		
			//Fetch settings record or set a new one
			if($id){
				$this->data['settings'] = $this->paypal_mdl->get($id);
				count($this->data['settings']) || $this->data['errors']['paypal_settings'] = 'Settings could not be found';
			}
			else {
				$this->data['settings'] = $this->paypal_mdl->get_new();
			}
			
			if(!IS_AJAX){
				$this->data['pagecontent'] = 'settings/paypal';
				$this->load->view('components/_layout', $this->data);
			}
			else
			{
				echo json_encode($response);
			}
	}
	public function templates($template_name = ''){
		$this->load->model('templates_mdl');
		$template_name = ($template_name != '') ? $template_name : 'ticket';
		if(!empty($_POST)){
			$rules = $this->templates_mdl->template_rules;
			$this->form_validation->set_rules($rules);
			if($this->form_validation->run())
			{
				$post_fields = array('template_name',
						'subject',
						'body',
				);
				$templates_data = $this->templates_mdl->array_from_post($post_fields);
				
				$this->db->where('template_name', $this->input->post('template_name'));
				$template_details = $this->templates_mdl->get(null, true);
				$id = (empty($template_details)) ? null : $template_details->id;
				$this->templates_mdl->save($templates_data, $id);
				$this->session->set_flashdata('success', 'template saved successfully');
				redirect('settings/templates/'.$template_name);
			}
		}
		
		$this->db->where('template_name', $template_name);
		$template_details = $this->templates_mdl->get(null, true);
		if(empty($template_details))
		{
			$template_details = $this->templates_mdl->get_new();
			$template_details->template_name = $template_name;
			$template_details->title = ucwords(str_replace('_', ' ', $template_name));
		}
		else{
			$template_details->title = ucwords(str_replace('_', ' ', $template_name));
		}
		
		
		$this->data['template_page'] = $template_details;
		$this->data['pagecontent'] = 'settings/templates';
		$this->load->view('components/_layout', $this->data);
	}
	function upload_logo($fieldname) {
		//set the path where the files uploaded will be copied. NOTE if using linux, set the folder to permission 777
		$config['upload_path'] = UPLOADSFOLDER;
		// set the filter image types
		$config['allowed_types'] = 'gif|jpg|png';
		$this->load->helper('string');
		$config['file_name']	 = random_string('alnum', 32);
		//load the upload library
		$this->load->library('upload', $config);
		$this->upload->initialize($config);
	
		//if not successful, set the error message
		if (!$this->upload->do_upload($fieldname)) {
			$data = array('success' => false, 'msg' => $this->upload->display_errors());
		}
		else
		{ //else, set the success message
			$upload_details = $this->upload->data();
			
			if($upload_details['is_image'] == 1){
				$logo_location = $config['upload_path'].$upload_details['file_name'];
				$this->resize_logo($logo_location);
			}
			$data = array('success' => true, 'upload_data' => $upload_details, 'msg' => "Upload success!");
		}
		return $data;
	}
	function resize_logo($logo_location){
		$this->load->library('image_lib');
		$configThumb = array();
		$configThumb['image_library']   = 'gd2';
		$configThumb['maintain_ratio']  = TRUE;
		$configThumb['source_image']	= $logo_location;
		$configThumb['width']           = 150;
		$configThumb['height']          = 150;
		$this->image_lib->initialize($configThumb);
		$this->image_lib->resize();
	}
}