<?php
class Timer extends Backend_Controller {
	
	function __construct() 
	{
		parent::__construct();
		$this->data['_menu'] = '';
		$this->load->model('timer_mdl');
	}
	
	public function save(){
		$project = $this->input->post('project');
		$project_task = $this->input->post('task');
		$start_timer = $this->input->post('start_timer');
		
		if($start_timer == 'true'){
			$user_id = $this->session->userdata('id');
			$timer_entry = array(
				'user_id' 		=> $user_id,
				'project_id' 	=> $project,
				'task' 			=> $project_task,
				'start_time' 	=> time(),
				'active' 		=> 1	
			);
			$timer_id = $this->timer_mdl->save($timer_entry);
			
			$this->db->join('projects', 'projects.project_id = timer_entries.project_id');
			$timer_data = $this->timer_mdl->get($timer_id);
			
			$project = $timer_data->project_id;
			$project_name = $timer_data->project_name;
			$response = array('success' => true, 'project_name' => $project_name, 'project' => $project);
		}
		else{
			$timer_entry = array(
					'stop_time' 	=> time(),
					'active' 	=> 0
			);
			$timer_id = $this->timer_mdl->stop_timer($timer_entry);
			$response = array('success' => true);
		}
		echo json_encode($response);
	
	}
	
	public function get_active_timer(){
		$user_id = $this->session->userdata('id');
		$this->db->where('user_id', $user_id);
		$this->db->where('active', 1);
		$this->db->join('projects', 'projects.project_id = timer_entries.project_id');
		$time_entry = $this->timer_mdl->get(null, true);
		
		if(!empty($time_entry)){
			$start_time = $time_entry->start_time;
			$end_time = time();
			
			$time_clocked = $end_time - $start_time;
			$project = $time_entry->project_id;
			$project_name = $time_entry->project_name;
			$task 	 = $time_entry->task;
			
			$response = array('has_timer' => true, 'timer_offset' => $time_clocked, 'project' => $project, 'project_name' => $project_name, 'task' => $task);
		}
		else {
			$response = array('has_timer' => false);
		}
		echo json_encode($response);
	}
}