<?php
function btn_edit($uri){
	return anchor($uri, '<button type="button" class="btn btn-labeled btn-xs btn-primary"><span class="btn-label"><i class="glyphicon glyphicon-edit"></i></span> View / edit
</button>');
}
function btn_delete($uri){
	return anchor($uri, '<button type="button" class=" btn btn-labeled btn-xs btn-danger"><span class="btn-label"><i class="glyphicon glyphicon-trash"></i></span> Trash
</button>', 'class="btn-delete"');
}

function success_msg($msg){
	$display = '<div class="alert alert-success alert-dismissable"><button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button> <strong>Success ! </strong> ' . $msg . ' </div>';
	return $display;
}

function error_msg($msg){
	$display = '<div class="alert alert-danger alert-dismissable"><button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button> <strong>Error ! </strong> ' . $msg . ' </div>';
	return $display;
}
function show_logo(){
	$CI = & get_instance();
	$CI->load->model('settings_mdl');
	$settings = $CI->settings_mdl->get(null, true);
	$logo = ($settings) ? $settings->company_logo : '';
	$display = ($logo != '') ? '<div class="text-center" style=" padding:5px; border:0px; "><img src="' . site_url(UPLOADSFOLDER.$logo) . '" alt="logo" width="30%"></div> ' : '';
	return $display;
}

function company_name(){
	$CI = & get_instance();
	$CI->load->model('settings_mdl');
	$settings = $CI->settings_mdl->get(null, true);
	$company = ($settings) ? $settings->company_name : '';
	return $company;
}

function invoice_status_img($status = ''){
	if($status == 'PAID')
		$img = 'paid.png';
	else 
		$img = 'unpaid.png';
	return '<img alt="status" src="'.site_url(IMAGESFOLDER.$img).'"/>';
}

function country_name($country_code = ''){
	$countries = config_item('country_list');
	return $countries[$country_code];
}

function check_installer(){
	$CI = & get_instance();
	$CI->load->database();
	if ($CI->db->database == "") {
		redirect('install');
		exit;
	} else {
		if (is_dir('install')) {
			$msg = '<div style="padding:50px;width:700px;margin:0 auto;text-align:center;background-color:#f2dede;color:#a94442"><i>Please delete or rename <b>Install</b> folder</i></div>';
			echo $msg;
			//header('location:install/');
			exit;
		}
	}
}

function get_client_id(){
	$CI = & get_instance();
	$CI->load->model('client_mdl');
	$CI->db->select('client_id');
	$CI->db->where('uacc_fk', $CI->session->userdata('id'));
	$logged_client = $CI->client_mdl->get(null, true);
	$client_id = $logged_client->client_id;
	return $client_id;
}

function status_label($status){
	if($status == 'DRAFT') : 
		$label = '<span class="label label-info"> ' . $status .' </span>';
	elseif ($status == 'UNPAID') : 
		$label = '<span class="label label-danger"> ' . $status .' </span>';
	elseif ($status == 'PAID') :
		$label = '<span class="label label-success"> ' . $status .' </span>';
	elseif ($status == 'open') :
		$label = '<span class="label label-warning"> ' . $status .' </span>';
	elseif ($status == 'closed') :
		$label = '<span class="label label-success"> ' . $status .' </span>';
	elseif ($status == 'completed') :
		$label = '<span class="label label-success"> ' . $status .' </span>';
	elseif ($status == 'pending') :
		$label = '<span class="label label-warning"> ' . $status .' </span>';
	else :
		$label = '<span class="label label-default"> ' . $status .' </span>';
	endif;
	return $label;
}

function usergroup_name($usergroup){
	$usergroup_name = '';
	if($usergroup == 1) 
		$usergroup_name = 'Master Admin';
	elseif ($usergroup == 2) 
		$usergroup_name = 'Admin';
	elseif ($usergroup == 3) 
		$usergroup_name = 'Client';
	
	return $usergroup_name;
}

function format_amount($amount = 0, $show_symbol = false){
	$CI = & get_instance();
	$CI->load->model('settings_mdl');
	$settings = $CI->settings_mdl->get(null, true);
	$formated_amount = ($show_symbol) ? $settings->currency . ' ' : '';
	$formated_amount .=  number_format($amount, $settings->decimal_places, $settings->decimal_separator, $settings->thousand_separator); 
	return $formated_amount;						
}

function format_date($date = ''){
	$CI = & get_instance();
	$CI->load->model('settings_mdl');
	$settings = $CI->settings_mdl->get(null, true);
	$formated_date = date($settings->date_format, strtotime($date));
	return $formated_date;
}

//selected country would be retrieved from a database or as post data
function  country_dropdown($name, $id, $class, $selected_country,$top_countries=array(), $all, $selection=NULL, $show_all=TRUE ){
	// You may want to pull this from an array within the helper
	$countries = config_item('country_list');

	$html = "<select name='{$name}' id='{$id}' class='{$class}' data-live-search='true' data-style='btn-success'>";
	$selected = NULL;
	if(in_array($selection,$top_countries)){
		$top_selection = $selection;
		$all_selection = NULL;
	}else{
		$top_selection = NULL;
		$all_selection = $selection;
	}
	if(!empty($selected_country)&&$selected_country!='all'&&$selected_country!='select'){
		$html .= "<optgroup label='Selected Country'>";
		if($selected_country === $top_selection){
			$selected = "SELECTED";
		}
		$html .= "<option value='{$selected_country}'{$selected}>{$countries[$selected_country]}</option>";
		$selected = NULL;
		$html .= "</optgroup>";
	}else if($selected_country=='all'){
		$html .= "<optgroup label='Selected Country'>";
		if($selected_country === $top_selection){
			$selected = "SELECTED";
		}
		$html .= "<option value='all'>All</option>";
		$selected = NULL;
		$html .= "</optgroup>";
	}else if($selected_country=='select'){
		$html .= "<optgroup label='Selected Country'>";
		if($selected_country === $top_selection){
			$selected = "SELECTED";
		}
		$html .= "<option value='select'>Select</option>";
		$selected = NULL;
		$html .= "</optgroup>";
	}
	if(!empty($all)&&$all=='all'&&$selected_country!='all'){
		$html .= "<option value='all'>All</option>";
		$selected = NULL;
	}
	if(!empty($all)&&$all=='select'&&$selected_country!='select'){
		$html .= "<option value='select'>Select</option>";
		$selected = NULL;
	}

	if(!empty($top_countries)){
		$html .= "<optgroup label='Top Countries'>";
		foreach($top_countries as $value){
			if(array_key_exists($value, $countries)){
				if($value === $top_selection){
					$selected = "SELECTED";
				}
				$html .= "<option value='{$value}'{$selected}>{$countries[$value]}</option>";
				$selected = NULL;
			}
		}
		$html .= "</optgroup>";
	}

	if($show_all){
		$html .= "<optgroup label='All Countries'>";
		foreach($countries as $key => $country){
			if($key === $all_selection){
				$selected = "SELECTED";
			}
			$html .= "<option value='{$key}'{$selected}>{$country}</option>";
			$selected = NULL;
		}
		$html .= "</optgroup>";
	}

	$html .= "</select>";
	return $html;
}

function timezone_select($selected = ''){
		$select_list = array(
			'Kwajalein' 				=> '(GMT -12:00) Eniwetok, Kwajalein',
			'Pacific/Midway' 			=> '(GMT -11:00) Midway Island, Samoa',
			'Pacific/Honolulu' 			=> '(GMT -10:00) Hawaii',
			'America/Anchorage' 		=> '(GMT -9:00) Alaska',
			'America/Los_Angeles' 		=> '(GMT -8:00) Pacific Time (US &amp; Canada)',
			'America/Denver' 			=> '(GMT -7:00) Mountain Time (US &amp; Canada)',
			'America/Tegucigalpa' 		=> '(GMT -6:00) Central Time (US &amp; Canada), Mexico City',
			'America/New_York' 			=> '(GMT -5:00) Eastern Time (US &amp; Canada), Bogota, Lima',
			'America/Caracas' 			=> '(GMT -4:30) America/Caracas',
			'America/Halifax' 			=> '(GMT -4:00) Atlantic Time (Canada), Caracas, La Paz',
			'America/St_Johns' 			=> '(GMT -3:30) Newfoundland',
			'America/Argentina/Buenos_Aires' 	=> '(GMT -3:00) Brazil, Buenos Aires, Georgetown',
			'Atlantic/South_Georgia' 	=> '(GMT -2:00) Mid-Atlantic',
			'Atlantic/Azores' 			=> '(GMT -1:00 hour) Azores, Cape Verde Islands',
			'Europe/Dublin' 			=> '(GMT) Western Europe Time, London, Lisbon, Casablanca',
			'Europe/Belgrade' 			=> '(GMT +1:00 hour) Brussels, Copenhagen, Madrid, Paris',
			'Europe/Minsk' 				=> '(GMT +2:00) Kaliningrad, South Africa',
			'Asia/Kuwait' 				=> '(GMT +3:00) Baghdad, Riyadh, Moscow, St. Petersburg',
			'Asia/Tehran' 				=> '(GMT +3:30) Tehran',
			'Asia/Muscat' 				=> '(GMT +4:00) Abu Dhabi, Muscat, Baku, Tbilisi',
			'Asia/Yekaterinburg' 		=> '(GMT +5:00) Ekaterinburg, Islamabad, Karachi, Tashkent',
			'Asia/Kolkata' 				=> '(GMT +5:30) Bombay, Calcutta, Madras, New Delhi',
			'Asia/Katmandu' 			=> '(GMT +5:45) Kathmandu',
			'Asia/Dhaka' 				=> '(GMT +6:00) Almaty, Dhaka, Colombo',
			'Asia/Rangoon' 				=> '(GMT +6:30) Asia/Rangoon',
			'Asia/Krasnoyarsk' 			=> '(GMT +7:00) Bangkok, Hanoi, Jakarta',
			'Asia/Brunei' 				=> '(GMT +8:00) Beijing, Perth, Singapore, Hong Kong',
			'Asia/Seoul' 				=> '(GMT +9:00) Tokyo, Seoul, Osaka, Sapporo, Yakutsk',
			'Australia/Darwin' 			=> '(GMT +9:30) Adelaide, Darwin',
			'Australia/Canberra' 		=> '(GMT +10:00) Eastern Australia, Guam, Vladivostok',
			'Asia/Magadan' 				=> '(GMT +11:00) Magadan, Solomon Islands, New Caledonia',
			'Pacific/Fiji' 				=> '(GMT +12:00) Auckland, Wellington, Fiji, Kamchatka',	
			'Pacific/Tongatapu' 		=> '(GMT +13:00) Pacific/Tongatapu',	
	);
	$select = form_dropdown('timezone', $select_list, $selected,  'class="form-control selectpicker" data-live-search="true" id="timezone"');
	
	return $select;
}

function time_elapsed ($start_time = 0, $stop_time = 0){
	$sec_diff = $stop_time - $start_time;
	$hours = $sec_diff / 3600;
	return number_format($hours, 3);
}

function format_number_of_hours($start_timestamp, $stop_timestamp=null)
{
	if($stop_timestamp!=null)
	{
		$span = $stop_timestamp - $start_timestamp;
	}
	else
	{
		$span = $start_timestamp;
	}
	if($span==0) return '00:00:00';
	$hours = floor ($span / 3600);
	$minutes=floor(($span-$hours*3600)/60);
	$seconds=$span - $hours*3600 - $minutes*60;
	$hours = ($hours<10) ? '0'.$hours : $hours;
	$minutes = ($minutes<10) ? '0'.$minutes : $minutes;
	$seconds = ($seconds<10) ? '0'.$seconds : $seconds;
	return $hours.':'.$minutes.':'.$seconds;
}
function timeDiff($datetime)
{
	$timespent = strtotime(date("Y-m-d H:i:s"))-strtotime($datetime);
	$years = floor(floatval($timespent) / (60 * 60 * 24 * 365));
	$months = floor(floatval($timespent) / (60 * 60 * 24 * 365 / 12));
	$days = floor($timespent / (60 * 60 * 24));
	$remainder = $timespent % (60 * 60 * 24);
	$hours = floor($remainder / (60 * 60));
	$remainder = $remainder % (60 * 60);
	$minutes = floor($remainder / 60);
	$seconds = $remainder % 60;
	if($years > 0)
		$TimeInterval = ($months==1) ? $years.' year ago' : $years.' years ago';
	else if($months > 0)
		$TimeInterval = ($months==1) ? $months.' month ago' : $months.' months ago';
	else if($days > 0)
		$TimeInterval = ($days==1) ? $days.' day ago' : $days.' days ago';
	elseif($days == 0 && $hours == 0 && $minutes == 0)
	$TimeInterval = "a few seconds ago";
	elseif($hours>0)
	$TimeInterval = ($hours==1) ? $hours.' hour ago' : $hours.' hours ago';
	elseif($days == 0 && $hours == 0)
	$TimeInterval = ($minutes==1) ? $minutes.' minute ago' : $minutes.' minutes ago';
	else
		$TimeInterval = "a few seconds ago";
	return $TimeInterval;
}

function date_format_select($selected = ''){
	$formats = array('d/m/Y' => date('d/m/Y'),
					 'm/d/Y' => date('m/d/Y'),
					 'Y/m/d' => date('Y/m/d'),
					 'F j, Y' => date('F j, Y'),
					 'm.d.y' => date('m.d.Y'),
					 'd-m-Y' => date('d-m-Y'),
					 'D M j Y' => date('D M j Y'),
			
	);
	$select = form_dropdown('date_format', $formats, $selected,  'class="form-control selectpicker" data-live-search="true" id="date_format"');
	return $select;
}
function time_format_select($selected = ''){
	$formats = array('H:i' => date('H:i'),
					 'g:i a' => date('g:i a'),
					 'g:i A' => date('g:i A'),			
	);
	$select = form_dropdown('time_format', $formats, $selected,  'class="form-control selectpicker" data-live-search="true" id="time_format"');
	return $select;
}
function delete_profile_pic($pic_name = ''){
	if(is_file(PROFILEPICSFOLDER.$pic_name)){
		unlink(PROFILEPICSFOLDER.$pic_name);
	}
}

