<?php 

class Notifications {
	//protected $CI;
	function __construct()
	{
		$this->CI =& get_instance();
		$this->CI->load->model('notifications_mdl');
		$this->CI->load->model('tickets_mdl');
		$this->CI->load->model('user_mdl');
		$this->CI->load->model('invoice_mdl');
		$this->CI->load->model('templates_mdl');
		
		$this->CI->load->library('parser');
		
		$config = Array(
				'mailtype'  => 'html',
				'charset'   => 'iso-8859-1'
		);
		$this->CI->load->library('email', $config);
		$this->CI->email->set_newline("\r\n");
		$this->CI->email->from("noreply@invotim.com",'invotim.com');
	}
	function new_ticket_admin($ticket_id = null, $assigned = false){
		$notification_subject = ($assigned) ? 'Ticket assigned to you' : 'New ticket created';
		$notification_content = ($assigned) ? 'You have been assigned to a clients\' ticket' : 'A client has opened a new ticket';
		$notification_link = 'support/view/'.$ticket_id;
		$ticket_details = $this->CI->tickets_mdl->get($ticket_id, true);
		$notification_details = array(
			'to_user' => null,
			'subject' => $notification_subject,
			'notification_content' => $notification_content,
			'notification_link'    => $notification_link
		);
		if($assigned){
			$notification_details['to_user'] = $ticket_details->assigned_to;
			$this->CI->notifications_mdl->save($notification_details);
			
		}
		else{
			$this->CI->db->where('user_group', 1);
			$admins =$this->CI->user_mdl->get();
			foreach($admins as $admin){
				if($admin->id != $ticket_details->assigned_to){
				$notification_details['to_user'] = $admin->id;
				$this->CI->notifications_mdl->save($notification_details);
				
				$this->CI->db->where('template_name', 'ticket');
				$template = $this->CI->templates_mdl->get(null, true);
				$data = array(
						'username'			=> $admin->firstname, 
						'ticket_number'		=> $ticket_details->ticket_number,
						'ticket_date'		=> format_date($ticket_details->created),
						'ticket_message'	=> $ticket_details->ticket_body,
						'company'			=> company_name(),
						'company_logo'		=> show_logo(),
				);
				$this->send_notification($template->body, $data, $admin->email, $template->subject);
				
				}
			}
		}		
	}
	function new_ticket_client($ticket_id = null){
		$notification_subject =  'New ticket opened for you';
		$notification_content =  'A new ticket has been opened for you by support';
		$notification_link = 'ctickets/view/'.$ticket_id;
		$this->CI->db->select('tickets.*, clients.uacc_fk AS to_user, clients.firstname, clients.email');
		$this->CI->db->join('clients', 'clients.client_id = tickets.client_id');
		$ticket_details = $this->CI->tickets_mdl->get($ticket_id, true);
		$notification_details = array(
				'to_user' => $ticket_details->to_user,
				'subject' => $notification_subject,
				'notification_content' => $notification_content,
				'notification_link'    => $notification_link
		);
		$this->CI->notifications_mdl->save($notification_details);
		
		$this->CI->db->where('template_name', 'ticket');
		$template = $this->CI->templates_mdl->get(null, true);
		$data = array(
				'username'			=> $ticket_details->firstname,
				'ticket_number'		=> $ticket_details->ticket_number,
				'ticket_date'		=> format_date($ticket_details->created),
				'ticket_message'	=> $ticket_details->ticket_body,
				'company'			=> company_name(),
				'company_logo'		=> show_logo(),
		);
		$this->send_notification($template->body, $data, $ticket_details->email, $template->subject);
	}
	
	function new_ticket_message_client($ticket_id = null, $message = ''){
		$notification_subject =  'New ticket reply for you';
		$notification_content =  'A reply has been posted to your ticket';
		$notification_link = 'ctickets/view/'.$ticket_id;
		$this->CI->db->select('tickets.*, clients.uacc_fk AS to_user, clients.firstname, clients.email');
		$this->CI->db->join('clients', 'clients.client_id = tickets.client_id');
		$ticket_details = $this->CI->tickets_mdl->get($ticket_id, true);
		$notification_details = array(
				'to_user' => $ticket_details->to_user,
				'subject' => $notification_subject,
				'notification_content' => $notification_content,
				'notification_link'    => $notification_link
		);
		$this->CI->notifications_mdl->save($notification_details);
		
		$this->CI->db->where('template_name', 'ticket');
		$template = $this->CI->templates_mdl->get(null, true);
		$data = array(
				'username'			=> $ticket_details->firstname,
				'ticket_number'		=> $ticket_details->ticket_number,
				'ticket_date'		=> format_date($ticket_details->created),
				'ticket_message'	=> $message,
				'company'			=> company_name(),
				'company_logo'		=> show_logo(),
		);
		$this->send_notification($template->body, $data, $ticket_details->email, $template->subject);
	}
	function new_ticket_message_admin($ticket_id = null, $message = ''){
		$notification_subject =  'New ticket reply for you';
		$notification_content =  'A reply has been posted to one of your tickets';
		$notification_link = 'support/view/'.$ticket_id;
		$ticket_details = $this->CI->tickets_mdl->get($ticket_id, true);
		
		$assigned = ($ticket_details->assigned_to != 0) ? true : false ;
		
		$notification_details = array(
				'to_user' => null,
				'subject' => $notification_subject,
				'notification_content' => $notification_content,
				'notification_link'    => $notification_link
		);
		 
		if($assigned){
			$notification_details['to_user'] = $ticket_details->assigned_to;
			$this->CI->notifications_mdl->save($notification_details);
		}
		else{
			$this->CI->db->where('user_group', 1);
			$admins =$this->CI->user_mdl->get();
			foreach($admins as $admin){
				if($admin->id != $ticket_details->assigned_to){
					$notification_details['to_user'] = $admin->id;
					$this->CI->notifications_mdl->save($notification_details);
				}
				
				$this->CI->db->where('template_name', 'ticket');
				$template = $this->CI->templates_mdl->get(null, true);
				$data = array(
						'username'			=> $admin->firstname,
						'ticket_number'		=> $ticket_details->ticket_number,
						'ticket_date'		=> format_date($ticket_details->created),
						'ticket_message'	=> $message,
						'company'			=> company_name(),
						'company_logo'		=> show_logo(),
				);
				$this->send_notification($template->body, $data, $admin->email, $template->subject);
			}
		}
	}
	
	function invoice_generated($invoice_id = null, $attachment =''){
		$notification_subject =  'New invoice generated';
		$notification_content =  'You received a new invoice';
		$notification_link = 'cinvoices/view/'.$invoice_id;
		
		$this->CI->db->select('clients.uacc_fk AS to_user, clients.firstname, clients.email');
		$this->CI->db->join('clients', 'clients.client_id = invoices.client_id');
		$invoice_details = $this->CI->invoice_mdl->get($invoice_id, true);
		
		$notification_details = array(
				'to_user' 				=> $invoice_details->to_user,
				'subject' 				=> $notification_subject,
				'notification_content' 	=> $notification_content,
				'notification_link'    	=> $notification_link
		);
		$this->CI->notifications_mdl->save($notification_details);
		
		$this->CI->db->where('template_name', 'invoice');
		$template = $this->CI->templates_mdl->get(null, true);
		$data = array(
				'username'			=> $invoice_details->firstname,
				'invoice_link'		=> $notification_link,
				'company'			=> company_name(),
				'invoice_logo'		=> show_logo(),
		);
		$this->send_notification($template->body, $data, $invoice_details->email, $notification_subject, $attachment);
	}
	function payment_received($invoice_id = null){
		$notification_subject =  'Payment Received';
		$notification_content =  'You received payment from a client';
		$notification_link = 'billing/invoice_pdf/'.$invoice_id;
		$notification_details = array(
				'to_user' => null,
				'subject' => $notification_subject,
				'notification_content' => $notification_content,
				'notification_link'    => $notification_link
		);
		$this->CI->db->where('user_group', 1);
		$admins =$this->CI->user_mdl->get();
		foreach($admins as $admin){
			$notification_details['to_user'] = $admin->id;
			$this->CI->notifications_mdl->save($notification_details);
			$this->CI->db->where('template_name', 'notification');
			$template = $this->CI->templates_mdl->get(null, true);
			$data = array(
					'username'			=> $admin->firstname,
					'message'			=> $notification_content,
					'company'			=> company_name(),
					'company_logo'		=> show_logo(),
			);
			$this->send_notification($template->body, $data, $admin->email, $notification_subject);				
		}
	}
	function send_notification($template = '', $data = array(), $to = '', $subject = '', $attachment = ''){
		//parse the template
		$email_body = $this->parse_template($template, $data);
		$this->CI->email->to($to);
		$this->CI->email->subject($subject);
		$this->CI->email->message($email_body);
		if($attachment != ''){
		$this->CI->email->attach($attachment);
		}
		$result = $this->CI->email->send();
		if($attachment != ''){
			unlink($attachment);
		}
		
	}
	function parse_template($html_template = '', $data = array()){
		$parsed_email_body = $this->CI->parser->parse_string($html_template, $data, TRUE);
		return $parsed_email_body;
	}
	function password_reset($user_details, $password){
		$this->CI->db->where('template_name', 'password_reset');
		$template = $this->CI->templates_mdl->get(null, true);
		$data = array(
				'username'			=> $user_details->firstname,
				'company'			=> company_name(),
				'login_link'		=> site_url(),
				'company_logo'		=> show_logo(),
				'password'			=> $password
		);
		$this->send_notification($template->body, $data, $user_details->email, $template->subject);
	}
	
	function login_details($user_details){
		$this->CI->db->where('template_name', 'login_details');
		$template = $this->CI->templates_mdl->get(null, true);
		$data = array(
				'username'			=> $user_details->username,
				'company'			=> company_name(),
				'login_link'		=> site_url(),
				'company_logo'		=> show_logo(),
				'password'			=> $user_details->password,
				'email'				=> $user_details->email
		);
		$this->send_notification($template->body, $data, $user_details->email, $template->subject);
	}
}