<?php 

class Migration_Create_clients extends CI_Migration {

	public function up()
	{
		$this->dbforge->add_field(array(
				'client_id' => array(
						'type' => 'INT',
						'constraint' => 11,
						'unsigned' => TRUE,
						'auto_increment' => TRUE
				),
				'firstname' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'lastname' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'email' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'password' => array(
						'type' => 'VARCHAR',
						'constraint' => '128',
				),
				'hourly_rate' => array(
						'type' => 'DOUBLE',
				),
				'address' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'company' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'town' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'city' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'country' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'created' => array(
						'type' => 'DATETIME',
				),
				'modified' => array(
						'type' => 'DATETIME',
				),
		));
		$this->dbforge->add_key('client_id', TRUE);
		$this->dbforge->create_table('clients');
	}

	public function down()
	{
		$this->dbforge->drop_table('clients');
	}
}