<?php 

class Migration_Create_projects extends CI_Migration {

	public function up()
	{
		$this->dbforge->add_field(array(
				'project_id' => array(
						'type' => 'INT',
						'constraint' => 11,
						'unsigned' => TRUE,
						'auto_increment' => TRUE
				),
				'project_name' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'client_id' => array(
						'type' => 'INT',
						'constraint' => 11,
				),
				'proect_status' => array(
						'type' => 'ENUM ("open", "closed")',
				),
				'hourly_rate' => array(
						'type' => 'DOUBLE',
				),
				'estimated_hours' => array(
						'type' => 'DOUBLE',
				),
				'budget' => array(
						'type' => 'DOUBLE',
				),
				'description' => array(
						'type' => 'TEXT',
				),
				'created' => array(
						'type' => 'DATETIME',
				),
				'modified' => array(
						'type' => 'DATETIME',
				),
		));
		$this->dbforge->add_key('project_id', TRUE);
		$this->dbforge->create_table('projects');
	}

	public function down()
	{
		$this->dbforge->drop_table('projects');
	}
}