<?php 

class Migration_Paypal_settings extends CI_Migration {

	public function up()
	{
		$this->dbforge->add_field(array(
				'id' => array(
						'type' => 'INT',
						'constraint' => 11,
						'unsigned' => TRUE,
						'auto_increment' => TRUE
				),
				'paypal_account' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'paypal_currency' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'paypal_ipn' => array(
						'type' => 'VARCHAR',
						'constraint' => '100',
				),
				'active' => array(
						'type' => 'ENUM',
						'constraint' => "'YES', 'NO'",
						'default' => 'YES',
				),
		));
		$this->dbforge->add_key('id', TRUE);
		$this->dbforge->create_table('paypal_settings');
	}

	public function down()
	{
		$this->dbforge->drop_table('paypal_settings');
	}
}