<?php 

class Migration_Timer_entries extends CI_Migration {

	public function up()
	{
		$this->dbforge->add_field(array(
				'id' => array(
						'type' => 'INT',
						'constraint' => 11,
						'unsigned' => TRUE,
						'auto_increment' => TRUE
				),
				'user_id' => array(
						'type' => 'INT',
						'constraint' => '11',
				),
				'project_id' => array(
						'type' => 'INT',
						'constraint' => '11',
				),
				'task' => array(
						'type' => 'VARCHAR',
						'constraint' => '255',
				),
				'start_time' => array(
						'type' => 'INT',
						'constraint' => '11',
						'default' => '0',
				),
				'stop_time' => array(
						'type' => 'INT',
						'constraint' => '11',
						'default' => '0',
				),
				'active' => array(
						'type' => 'TINYINT',
						'constraint' => '1',
						'default' => '1',
				),
				'is_invoiced' => array(
						'type' => 'ENUM',
						'constraint' => " '0', '1' ",
						'default' => '0',
				),
		));
		$this->dbforge->add_key('id', TRUE);
		$this->dbforge->create_table('timer_entries');
	}

	public function down()
	{
		$this->dbforge->drop_table('timer_entries');
	}
}