<?php 

class Migration_Invoices extends CI_Migration {

	public function up()
	{
		$this->dbforge->add_field(array(
				'invoice_id' => array(
						'type' => 'INT',
						'constraint' => 11,
						'unsigned' => TRUE,
						'auto_increment' => TRUE
				),
				'invoice_number' => array(
						'type' => 'VARCHAR',
						'constraint' => '255',
				),
				'client_id' => array(
						'type' => 'INT',
						'constraint' => '11',
				),
				'project_id' => array(
						'type' => 'INT',
						'constraint' => '11',
				),
				'invoice_status' => array(
						'type' => 'ENUM',
						'constraint' => " 'DRAFT', 'UNPAID',  'PAID'",
						'default' => 'DRAFT',
				),
				'due_date' => array(
						'type' => 'DATETIME',
				),
				'created' => array(
						'type' => 'DATETIME',
				),
				'modified' => array(
						'type' => 'DATETIME',
				),
		));
		$this->dbforge->add_key('invoice_id', TRUE);
		$this->dbforge->create_table('invoices');
	}

	public function down()
	{
		$this->dbforge->drop_table('invoices');
	}
}