<?php 

class Migration_Tickets extends CI_Migration {

	public function up()
	{
			   $this->dbforge->add_field(array(
				'ticket_id' => array(
						'type' => 'INT',
						'constraint' => 11,
						'unsigned' => TRUE,
						'auto_increment' => TRUE
				),
				'ticket_number' => array(
						'type' => 'VARCHAR',
						'constraint' => '255',
				),
				'client_id' => array(
						'type'	=> 'INT',
						'constraint' => 11,
				),
				'subject' => array(
						'type' => 'VARCHAR',
						'constraint' => '255',
				),
		   		'ticket_body' => array(
		   				'type' => 'TEXT',
		   		),
		   		'attachment' => array(
		   				'type' => 'VARCHAR',
		   				'constraint' => '255',
		   		),
				'assigned_to' => array(
						'type' => 'INT',
						'constraint' => 11,
				),
		   		'ticket_status' => array(
		   				'type' => 'ENUM',
		   				'constraint' => "'open', 'closed'",
		   				'default' => "open"
		   		),
				'created' => array(
						'type' => 'DATETIME',
				),
				'modified' => array(
						'type' => 'DATETIME',
				),
		));
		$this->dbforge->add_key('ticket_id', TRUE);
		$this->dbforge->create_table('tickets');
	}

	public function down()
	{
		$this->dbforge->drop_table('tickets');
	}
}