<?php 

class Migration_Notifications extends CI_Migration {

	public function up()
	{
			   $this->dbforge->add_field(array(
				'notification_id' => array(
						'type' => 'INT',
						'constraint' => 11,
						'unsigned' => TRUE,
						'auto_increment' => TRUE
				),
				'to_user' => array(
						'type'	=> 'INT',
						'constraint' => 11,
				),
		   		'subject' => array(
		   				'type' => 'VARCHAR',
						'constraint' => '255',
		   		),
				'notification_content' => array(
						'type'	=> 'TEXT',
				),
		   		'notification_link' => array(
		   				'type'	=> 'VARCHAR',
		   				'constraint' => '255',
		   		),
				'seen' => array(
						'type' => 'ENUM',
						'constraint' => "'1', '0'",
						'default' => '0',
				),
				'timestamp' => array(
						'type' => 'TIMESTAMP',
				),
		));
		$this->dbforge->add_key('notification_id', TRUE);
		$this->dbforge->create_table('notifications');
	}

	public function down()
	{
		$this->dbforge->drop_table('notifications');
	}
}