<?php
class Client_Mdl extends MY_Model 
{
	protected $_table_name = 'clients';
	protected $_primary_key = 'client_id';
	protected $_order_by = 'client_id DESC';
	protected $_timestamps = TRUE;
	
	public $register_rules = array(
			'firstname' => array (
					'field' => 'firstname',
					'label' => 'first name',
					'rules' => 'trim|required|xss_clean'
			),
			'lastname' => array (
					'field' => 'lastname',
					'label' => 'last name',
					'rules' => 'trim|required|xss_clean'
			),
			'email' => array (
					'field' => 'email',
					'label' => 'email',
					'rules' => 'trim|required|valid_email|callback__unique_email|xss_clean'
			),
			'hourly_rate' => array (
					'field' => 'hourly_rate', 
					'label' => 'hourly rate', 
					'rules' => 'trim|numeric|xss_clean' 
				),
			'address' => array (
					'field' => 'address',
					'label' => 'address', 
					'rules' => 'trim|xss_clean' 
				),
			'company' => array (
					'field' => 'company',
					'label' => 'company',
					'rules' => 'trim|xss_clean'
				),
			'city' => array (
					'field' => 'city',
					'label' => 'city',
					'rules' => 'trim|xss_clean'
			),
			'country' => array (
					'field' => 'country',
					'label' => 'country',
					'rules' => 'trim|xss_clean'
			),
			'password' => array (
					'field' => 'password',
					'label' => 'password',
					'rules' => 'trim|matches[cpassword]'
			),
			'cpassword' => array (
					'field' => 'cpassword',
					'label' => 'confirm password',
					'rules' => 'trim||matches[password]'
			),
			);
	
	function __construct() 
	{
		parent::__construct();
	}
	public function get_new(){
		$client = new stdClass ();
		$client->client_id 		= null;
		$client->uacc_fk 		= null;
		$client->firstname 		= '';
		$client->lastname 		= '';
		$client->email 			= '';
		$client->hourly_rate 	= '';
		$client->address 		= '';
		$client->company 		= '';
		$client->city 			= '';
		$client->country 		= '';
		return $client;
	}
	public function clients_dropdown()
	{
		$clients_select = array('' => 'Select a client');
		$clients = $this->get();
		if (count($clients)) : foreach ($clients as $client) :
		$clients_select[$client->client_id] = $client->firstname . ' ' . $client->lastname;
		endforeach;
		endif;
	
		return $clients_select;
	}
	
	public function delete_client($client_id = null){
		// TODO : delete payments
		
		$delete_qry = "DELETE clients, users, projects, timer_entries, invoices, invoice_items, tickets, ticket_messages  FROM clients
		LEFT JOIN users ON users.id = clients.uacc_fk
		LEFT JOIN projects ON projects.client_id = clients.client_id
		LEFT JOIN timer_entries ON timer_entries.project_id = projects.project_id
		LEFT JOIN invoices ON invoices.client_id = clients.client_id
		LEFT JOIN invoice_items ON invoice_items.invoice_id = invoices.invoice_id
		LEFT JOIN tickets ON tickets.client_id = clients.client_id
		LEFT JOIN ticket_messages ON ticket_messages.ticket_id = tickets.ticket_id
		WHERE clients.client_id = $client_id";
		
		$this->db->query($delete_qry);
		
	}
}