<?php
class Invoice_Mdl extends MY_Model
{
	protected $_table_name = 'invoices';
	protected $_primary_key = 'invoice_id';
	protected $_order_by    = 'invoices.invoice_id DESC';
	protected $_timestamps = TRUE;
	
	function __construct()
	{
		parent::__construct();
	}
	public function delete_invoice($invoice_id = null){
		$delete_qry = "DELETE invoices, invoice_items  FROM invoices
		LEFT JOIN invoice_items ON invoice_items.invoice_id = invoices.invoice_id
		LEFT JOIN payments ON payments.invoice_id = invoices.invoice_id
		WHERE invoices.invoice_id = $invoice_id";
		$this->db->query($delete_qry);
	}
	
	public function get_invoice_total_amt($invoice_id = null){
		$this->db->select_sum('amount + (amount * tax)/100', 'invoice_amount');
		$this->db->join('invoice_items' , 'invoice_items.invoice_id = invoices.invoice_id');
		$this->db->where('invoices.invoice_id = ', $invoice_id);
		$invoice_amt = $this->get(null, true);
		return $invoice_amt->invoice_amount;
	}
	public function get_invoice_paid_amt($invoice_id = null){
		$this->db->select_sum('payment_amount', 'paid_amount');
		$this->db->join('payments' , 'payments.invoice_id = invoices.invoice_id');
		$this->db->where('invoices.invoice_id = ', $invoice_id);
		$invoice_amt = $this->get(null, true);
		return $invoice_amt->paid_amount;
	}
	public function set_invoice_status($invoice_id = null){
		$invoice_amt = $this->get_invoice_total_amt($invoice_id);
		$paid_amt = $this->get_invoice_paid_amt($invoice_id);
		$invoice_status = ($invoice_amt - $paid_amt < 1) ? 'PAID' : 'UNPAID';
		$status = array('invoice_status' => $invoice_status);
		$this->save($status, $invoice_id);
	}
	
}
