<?php
class Payment_Mdl extends MY_Model 
{
	protected $_table_name = 'payments';
	protected $_primary_key = 'payment_id';
	protected $_order_by = 'payment_id DESC';
	
	public $payment_rules = array(
			'invoice_id' => array (
					'field' => 'invoice_id',
					'label' => 'invoice id',
					'rules' => 'trim|required|xss_clean'
			),
			'payment_date' => array (
					'field' => 'payment_date',
					'label' => 'payment date',
					'rules' => 'trim|required|xss_clean'
			),
			'payment_amount' => array (
					'field' => 'payment_amount',
					'label' => 'payment amount',
					'rules' => 'trim|required|numeric|xss_clean'
			),
			'payment_method' => array (
					'field' => 'payment_method', 
					'label' => 'payment method', 
					'rules' => 'trim|required|xss_clean' 
				),
			'payment_note' => array (
					'field' => 'payment_note',
					'label' => 'payment note', 
					'rules' => 'trim|xss_clean' 
				),
			);
	
	function __construct() 
	{
		parent::__construct();
	}
	
	function total_earnings(){
		$qry = "SELECT SUM(CASE WHEN MONTHNAME(payment_date) = 'January' THEN payment_amount ELSE 0 END) AS Jan,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'February' THEN payment_amount ELSE 0 END) AS Feb,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'March' THEN payment_amount ELSE 0 END) AS Mar,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'April' THEN payment_amount ELSE 0 END) AS Apr,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'May' THEN payment_amount ELSE 0 END) AS May,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'June' THEN payment_amount ELSE 0 END) AS Jun,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'July' THEN payment_amount ELSE 0 END) AS Jul,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'August' THEN payment_amount ELSE 0 END) AS Aug,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'September' THEN payment_amount ELSE 0 END) AS Sept,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'October' THEN payment_amount ELSE 0 END) AS Oct,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'November' THEN payment_amount ELSE 0 END) AS Nov,
				SUM(CASE WHEN MONTHNAME(payment_date) = 'December' THEN payment_amount ELSE 0 END) AS Dece
				FROM payments WHERE YEAR(payment_date) = YEAR(CURRENT_DATE)";
	
		$earnings = $this->db->query($qry);
		return $earnings->result_array();
	}
}