<?php
class Project_Mdl extends MY_Model 
{
	protected $_table_name = 'projects';
	protected $_primary_key = 'project_id';
	protected $_order_by = 'project_id DESC';
	protected $_timestamps = TRUE;
	
	public $project_rules = array(
			'project_name' => array (
					'field' => 'project_name',
					'label' => 'project name',
					'rules' => 'trim|required|xss_clean'
			),
			'client_id' => array (
					'field' => 'client_id',
					'label' => 'client',
					'rules' => 'trim|required|xss_clean'
			),
			'project_status' => array (
					'field' => 'project_status',
					'label' => 'project status',
					'rules' => 'trim|required|xss_clean'
			),
			'hourly_rate' => array (
					'field' => 'hourly_rate',
					'label' => 'hourly rate',
					'rules' => 'trim|numeric|xss_clean'
			),
			'estimated_hours' => array (
					'field' => 'estimated_hours', 
					'label' => 'estimated hours', 
					'rules' => 'trim|numeric|xss_clean' 
				),
			'budget' => array (
					'field' => 'budget',
					'label' => 'budget', 
					'rules' => 'trim|numeric|xss_clean' 
				),
			'description' => array (
					'field' => 'description',
					'label' => 'description',
					'rules' => 'trim|xss_clean'
				)
			);
	
	function __construct() 
	{
		parent::__construct();
	}
	public function get_new(){
		$project = new stdClass ();
		$project->client_id 		= null;
		$project->project_id		= null;
		$project->project_name 		= '';
		$project->project_status 	= '';
		$project->hourly_rate 		= '';
		$project->estimated_hours 	= '';
		$project->budget 			= '';
		$project->description 		= '';
		return $project;
	}
	public function projects_dropdown()
	{
		$projects_select = array('' => 'Select a project');
		$projects = $this->get();
		if (count($projects)) : foreach ($projects as $project) :
		$projects_select[$project->project_id] = $project->project_name;
		endforeach;
		endif;
	
		return $projects_select;
	}
	public function delete_project($project_id = null){
		// TODO delete payments
		$delete_qry = "DELETE projects, timer_entries, invoices, invoice_items  FROM projects
		LEFT JOIN invoices ON invoices.project_id = projects.project_id
		LEFT JOIN invoice_items ON invoice_items.invoice_id = invoices.invoice_id
		LEFT JOIN timer_entries ON timer_entries.project_id = projects.project_id
		WHERE projects.project_id = $project_id";
		$this->db->query($delete_qry);
	}

}