<?php
class Settings_Mdl extends MY_Model
{
	protected $_table_name = 'config';
	protected $_order_by = 'id';
	protected $_timestamps = FALSE;

	public $settings_rules = array(
			'company_name' => array (
					'field' => 'company_name',
					'label' => 'company name',
					'rules' => 'trim|xss_clean'
			),
			'address' => array (
					'field' => 'address',
					'label' => 'address',
					'rules' => 'trim|xss_clean'
			),
			'email' => array (
					'field' => 'email',
					'label' => 'email',
					'rules' => 'trim|valid_email|xss_clean'
			),
			'city' => array (
					'field' => 'city',
					'label' => 'city',
					'rules' => 'trim|xss_clean'
			),
			'phone' => array (
					'field' => 'phone',
					'label' => 'phone',
					'rules' => 'trim|xss_clean'
			),
			'website' => array (
					'field' => 'website',
					'label' => 'website',
					'rules' => 'trim|xss_clean'
			),
			'timezone' => array (
					'field' => 'timezone',
					'label' => 'timezone',
					'rules' => 'trim|xss_clean'
			),
			'tax' => array (
					'field' => 'tax',
					'label' => 'tax',
					'rules' => 'trim|numeric|xss_clean'
			),
			'date_format' => array (
					'field' => 'date_format',
					'label' => 'date format',
					'rules' => 'trim|xss_clean'
			),
			'time_format' => array (
					'field' => 'time_format',
					'label' => 'time format',
					'rules' => 'trim|xss_clean'
			),
			'currency' => array (
					'field' => 'currency',
					'label' => 'currency',
					'rules' => 'trim|xss_clean'
			),
			'decimal_places' => array (
					'field' => 'decimal_places',
					'label' => 'decimal places',
					'rules' => 'trim|xss_clean'
			),
			'decimal_separator' => array (
					'field' => 'decimal_separator',
					'label' => 'decimal separator',
					'rules' => 'trim|max_length[1]|xss_clean'
			),
			'thousand_separator' => array (
					'field' => 'thousand_separator',
					'label' => 'thousand separator',
					'rules' => 'trim|max_length[1]|xss_clean'
			),
			'invoice_due_days' => array (
					'field' => 'invoice_due_days',
					'label' => 'invoice payment due days',
					'rules' => 'trim|numeric|xss_clean'
			),
	);

	function __construct()
	{
		parent::__construct();
	}
	
	public function get_new(){
		$settings = new stdClass ();
		$settings->id 			= null;
		$settings->company_name = '';
		$settings->address 		= '';
		$settings->city 		= '';
		$settings->email 		= '';
		$settings->phone 		= '';
		$settings->website 		= '';
		$settings->timezone 	= '';
		$settings->company_logo	= '';
		$settings->invoice_logo	= '';
		$settings->tax 			= '';
		$settings->date_format 	= '';
		$settings->currency 	= '';
		$settings->time_format 	= '';
		$settings->decimal_places	= '';
		$settings->decimal_separator = '';
		$settings->thousand_separator = '';
		$settings->invoice_due_days = '';
		return $settings;
	}
}