<?php
class Tickets_Mdl extends MY_Model
{
	public $_table_name = 'tickets';
	protected $_order_by = 'ticket_id DESC';
	public $_primary_key = 'ticket_id';
	protected $_timestamps = TRUE;

	public $ticket_rules = array(
			'client_id' => array (
					'field' => 'client_id',
					'label' => 'client',
					'rules' => 'trim|required|xss_clean'
			),
			'subject' => array (
					'field' => 'subject',
					'label' => 'ticket subject',
					'rules' => 'trim|required|xss_clean'
			),
			'ticket_body' => array (
					'field' => 'ticket_body',
					'label' => 'ticket content',
					'rules' => 'trim|required|xss_clean'
			),
	);
	
	public $update_ticket_rules = array(
			'client_id' => array (
					'field' => 'client_id',
					'label' => 'client',
					'rules' => 'trim|required|xss_clean'
			),
			'assigned_to' => array (
					'field' => 'assigned_to',
					'label' => 'agent',
					'rules' => 'trim|required|xss_clean'
			),
			'ticket_status' => array (
					'field' => 'ticket_status',
					'label' => 'ticket status',
					'rules' => 'trim|required|xss_clean'
			),
	);
	
	public $ticket_message_rules = array (
			'message_content'	=> array (
					'field' => 'message_content',
					'label' => 'message',
					'rules' => 'trim|required|xss_clean'
			), 
			
	);

	function __construct()
	{
		parent::__construct();
	}
	
	function get_tickets($filter = 'all'){
		$this->db->select('tickets.*, users.firstname AS agent_firstname, users.lastname AS agent_lastname');
		$this->db->select('tickets.*, clients.firstname AS client_firstname, clients.lastname AS client_lastname');
		$this->db->join('clients', 'clients.client_id = tickets.client_id', 'LEFT');
		$this->db->join('users', 'users.id = tickets.assigned_to', 'LEFT');
		if($filter != 'all')
		{
			if($filter !='my_tickets')
				$this->db->where ('ticket_status', $filter);
			else
				$this->db->where ('assigned_to', $this->session->userdata('id'));
		}
		$tickets = $this->get();
		
		return $tickets;
	}
	function view_ticket($id = null){
		$this->db->select('tickets.*, users.firstname AS agent_firstname, users.lastname AS agent_lastname, users.id AS agent_id');
		$this->db->select('tickets.*, clients.firstname AS client_firstname, clients.lastname AS client_lastname, clients.email AS client_email, clients.company AS client_company, clients.country AS client_country');
		$this->db->join('clients', 'clients.client_id = tickets.client_id', 'LEFT');
		$this->db->join('users', 'users.id = tickets.assigned_to', 'LEFT');
		$ticket = $this->get($id, true);
		
		$this->db->where('ticket_id = ', $id);
		$messages = $this->db->get('ticket_messages')->result();
		$ticket->messages = $messages;
		return $ticket;
		
	}
}