<?php
class Timer_Mdl extends MY_Model 
{
	protected $_table_name = 'timer_entries';
	protected $_primary_key = 'id';
	protected $_order_by = 'id DESC';
	protected $_timestamps = FALSE;
	
	
	function __construct() 
	{
		parent::__construct();
	}
	
	function stop_timer($timer_details = array())
	{
		$this->db->set($timer_details);
		$this->db->where('user_id',  $this->session->userdata('id'));
		$this->db->where('active',  1);
		$this->db->update($this->_table_name);
	}
	function latest_entries(){
		$this->db->join('projects', 'projects.project_id = timer_entries.project_id', 'LEFT');
		$this->db->where('timer_entries.active = ', 0);
		$this->db->limit(5);
		$entries = $this->get();
		return $entries;
	}
	function total_hours_clocked(){
		$total_hours = 0;
		$this->db->select_sum('(stop_time - start_time)','totalTime');
		$this->db->where('active',0);
		$entries = $this->get(null, true);
		$total_hours = (!empty($entries)) ? $entries->totalTime : $total_hours;
		return $total_hours;
	}
	function this_week_hours(){
		$total_hours = 0;
		$this->db->select_sum('(stop_time - start_time)','totalTime');
		$this->db->where('active',0);
		$this->db->where("YEARWEEK(FROM_UNIXTIME(stop_time)) = YEARWEEK(CURRENT_DATE)");
		$entries = $this->get(null, true);
		$total_hours = (!empty($entries)) ? $entries->totalTime : $total_hours;
		return $total_hours;
	}
	
	function monthly_hours(){
		$qry = "SELECT SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'January' THEN (stop_time - start_time) ELSE 0 END) AS January,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'February' THEN (stop_time - start_time) ELSE 0 END) AS February,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'March' THEN (stop_time - start_time) ELSE 0 END) AS March,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'April' THEN (stop_time - start_time) ELSE 0 END) AS April,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'May' THEN (stop_time - start_time) ELSE 0 END) AS May,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'June' THEN (stop_time - start_time) ELSE 0 END) AS June,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'July' THEN (stop_time - start_time) ELSE 0 END) AS July,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'August' THEN (stop_time - start_time) ELSE 0 END) AS August,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'September' THEN (stop_time - start_time) ELSE 0 END) AS September,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'October' THEN (stop_time - start_time) ELSE 0 END) AS October,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'November' THEN (stop_time - start_time) ELSE 0 END) AS November,
				SUM(CASE WHEN MONTHNAME(FROM_UNIXTIME(start_time)) = 'December' THEN (stop_time - start_time) ELSE 0 END) AS December
				FROM timer_entries WHERE active = 0 AND YEAR(FROM_UNIXTIME(start_time)) = YEAR(CURRENT_DATE)";

		$hours = $this->db->query($qry);
		return $hours->result_array();
	}

}