<?php
class User_Mdl extends MY_Model 
{
	protected $_table_name = 'users';
	protected $_order_by = 'id';
	protected $_timestamps = TRUE;
	
	public $register_rules = array(
			'firstname' => array (
					'field' => 'firstname',
					'label' => 'first name',
					'rules' => 'trim|required|xss_clean'
			),
			'lastname' => array (
					'field' => 'lastname',
					'label' => 'last name',
					'rules' => 'trim|required|xss_clean'
			),
			'email' => array (
					'field' => 'email',
					'label' => 'email',
					'rules' => 'trim|required|valid_email|callback__unique_email|xss_clean'
			),
			'password' => array (
					'field' => 'password', 
					'label' => 'password', 
					'rules' => 'trim|matches[cpassword]' 
				),
			'cpassword' => array (
					'field' => 'cpassword',
					'label' => 'confirm password', 
					'rules' => 'trim|matches[password]' 
				),
			'user_group' => array (
					'field' => 'user_group',
					'label' => 'user group',
					'rules' => 'trim|required'
				),
			);
	public $profile_rules = array(
			'firstname' => array (
					'field' => 'firstname',
					'label' => 'first name',
					'rules' => 'trim|required|xss_clean'
			),
			'lastname' => array (
					'field' => 'lastname',
					'label' => 'last name',
					'rules' => 'trim|required|xss_clean'
			),
			'email' => array (
					'field' => 'email',
					'label' => 'email',
					'rules' => 'trim|required|valid_email|callback__unique_email|xss_clean'
			),
			'password' => array (
					'field' => 'password',
					'label' => 'password',
					'rules' => 'trim|matches[cpassword]'
			),
			'cpassword' => array (
					'field' => 'cpassword',
					'label' => 'confirm password',
					'rules' => 'trim|matches[password]'
			),
	);
	public $login_rules = array(
			'username' => array (
					'field' => 'username',
					'label' => 'email',
					'rules' => 'trim|required|valid_email|xss_clean'
			),
			'password' => array (
					'field' => 'password',
					'label' => 'Password',
					'rules' => 'trim|required'
			),
	);
	
	public $password_reset_rules = array(
			'email' => array(
				 'field' => 'email',
				 'label' => 'email',
				 'rules' => 'trim|valid_email|required|xss_clean'
	)
	);
	
	function __construct() 
	{
		parent::__construct();
	}
	
	public function login() 
	{
		$user = $this->get_by(array(
				'email' => $this->input->post('username'),
				'password' => $this->hash($this->input->post('password')),
			), TRUE);
		
		if (count($user)) {
			//log in user
		 	$data = array (
				'name' => $user->firstname . ' ' . $user->lastname,
				'profile_pic' => $user->profile_pic,
				'id' => $user->id,
		 		'user_group' => $user->user_group,
				'loggedin' => TRUE,
			);
			$this->session->set_userdata($data);
			return true;
		}
		else{
			return false;
		}
	}
	
	public function update_session_data(){
		$logged_user = $this->session->userdata('id');
		
		$user = $this->get_by(array(
				'id' => $logged_user
		), TRUE);
		
		$data = array (
				'name' => $user->firstname . ' ' . $user->lastname,
				'profile_pic' => $user->profile_pic,
				'user_group' => $user->user_group,
		);
		$this->session->set_userdata($data);
	}
	
	public function loggedin()
	{
		return (bool) $this->session->userdata('loggedin');
	}
	public function get_new(){
		$user = new stdClass ();
		$user->id 			= null;
		$user->firstname 	= '';
		$user->lastname 	= '';
		$user->email 		= '';
		$user->password 	= '';
		$user->telephone 	= '';
		$user->user_group 	= '';
		$user->profile_pic 	= '';
		return $user;
	}
	public function logout()
	{
		$this->session->sess_destroy();
	}
	public function hash($string)
	{
		return hash('sha512', $string.config_item('encryption_key'));
	}
	
	public function agents_dropdown(){
		$agents_select = array('' => 'Select an agent');
		$this->db->where('user_group != ', 3);
		$agents = $this->get();
		if (count($agents)) : foreach ($agents as $agents) :
		$agents_select[$agents->id] = ucwords($agents->firstname . ' ' . $agents->lastname);
		endforeach;
		endif;
		
		return $agents_select;
	}
}