<link rel="stylesheet" href="<?php echo site_url(RESOURCESFOLDER.'font-awesome/css/font-awesome.min.css'); ?>">
<div class="row">
	<div class="col-lg-6">
		<div class="panel panel-primary">
			<div class="panel-heading">
				<i class="glyphicon glyphicon-time"></i> Statistics
			</div>
			<!-- /.panel-heading -->
			<div class="panel-body">	
				<div class="col-lg-6">
						<div class="panel panel-warning">
					              <div class="panel-heading">
					                <div class="row">
					                  <div class="col-xs-3">
					                    <i class="fa fa-tasks fa-5x"></i>
					                  </div>
					                  <div class="col-xs-9 text-right">
					                    <p class="announcement-heading"><?php echo $projects->closed_projects . '/' . $projects->total_projects; ?></p>
					                    <p class="announcement-text">Completed Projects</p>
					                  </div>
					                </div>
					              </div>
				            </div>
					</div>
					
					<div class="col-lg-6">
					<div class="panel panel-info">
				              <div class="panel-heading">
				                <div class="row">
				                  <div class="col-xs-3">
				                    <i class="fa fa-clock-o fa-5x"></i>
				                  </div>
				                  <div class="col-xs-9 text-right">
				                    <p class="announcement-heading"><?php echo format_number_of_hours($total_hours_clocked); ?></p>
				                    <p class="announcement-text">Hours Worked</p>
				                  </div>
				                </div>
				              </div>
			            </div>
					</div>
					
					<div class="col-lg-6">
					<div class="panel panel-primary">
				              <div class="panel-heading">
				                <div class="row">
				                  <div class="col-xs-3">
				                    <i class="fa fa-money fa-5x"></i>
				                  </div>
				                  <div class="col-xs-9 text-right">
				                    <p class="announcement-heading"><?php echo $total_invoices; ?></p>
				                    <p class="announcement-text">Invoices Created</p>
				                  </div>
				                </div>
				              </div>
			            </div>
					</div>
					
					<div class="col-lg-6">
					<div class="panel panel-success">
				              <div class="panel-heading">
				                <div class="row">
				                  <div class="col-xs-3">
				                    <i class="fa fa-check fa-5x"></i>
				                  </div>
				                  <div class="col-xs-9 text-right">
				                    <p class="announcement-heading"><?php echo $total_received; ?></p>
				                    <p class="announcement-text">Amount Received</p>
				                  </div>
				                </div>
				              </div>
			            </div>
					</div>
				
			</div>
			<!-- /.panel-body -->
		</div>
	</div>
	<div class="col-lg-6">
	<div class="panel panel-primary">
			<div class="panel-heading">
				<i class="glyphicon glyphicon-time"></i> Start / Stop Timer
			</div>
			<!-- /.panel-heading -->
			<div class="panel-body">
				<div class="col-lg-8">
					<div class="form-group">
                       <label>Project</label>
                       <?php echo form_dropdown('projects', $projects_select, '', 'class="form-control selectpicker" id="selected_project" data-live-search="true" data-style="btn-info"'); ?>
                 	</div>
					
					<div class="form-group">
                       <label>Task</label>
                       <?php echo form_textarea('project_task', '', 'class="form-control" id="project_task" style="resize: none; height:100px"'); ?>
                 	</div>
        		</div>
        		<div class="col-lg-4" id="timer-holder">
           			<!-- Timer section -->
           			<div class="col-lg-12 dashboard-timer"><span class="timer-clock">00:00:00</span></div>
           			
           			<div class="col-lg-12 start-stop-div text-center">
           			<button class="btn btn-block btn-success btn-circle countdown-timer btn-lg" id="start-timer" data-toggle="tooltip">
           			<span class="glyphicon glyphicon-play"></span> </button>
           			</div>
        		</div>
			</div>
			<!-- /.panel-body -->
		</div>
	</div>
</div>
<!-- /.row -->
<div class="row">
	<div class="col-lg-12">
		<div class="panel panel-primary">
			<div class="panel-heading">
				<i class="glyphicon glyphicon-time"></i> Latest Time Entries
				<div class="pull-right">
					<div class="btn-group">
						<button type="button" class="btn btn-primary btn-xs dropdown-toggle" data-toggle="dropdown">
							Show All Entries
						</button>
					</div>
				</div>
			</div>
			<!-- /.panel-heading -->
			<div class="panel-body">
		  						<table class="table table-striped table-bordered table-hover">
                                    <thead>
                                        <tr class="table_header">
                                            <th style="width: 13%">Date</th>
                                            <th style="width: 13%">Project</th>
                                            <th style="width: 18%">Task</th>
                                            <th style="width: 10%" class="text-right">Hours worked</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                      <?php 
                                      $count = 1;
                                      if (count($latest_entries)) : foreach ($latest_entries as $entry) : ?>
                                      <tr>
                                      	<td><?php echo format_date(date('Y-m-d', $entry->start_time)); ?></td>
                                      	<td><?php echo $entry->project_name; ?></td>
                                      	<td><?php echo $entry->task; ?></td>
                                      	<td class="text-right"><span class="label label-warning"><?php echo time_elapsed($entry->start_time, $entry->stop_time) ; ?></span></td>
                                      </tr>
                                      <?php 
                                      	$count++;
                                      	endforeach; 
                                      	else : ?>
                                      	<tr><td colspan="5">No time entries has been recorded at the moment</td></tr>
                                      <?php  endif;?> 
                                    </tbody>
                                </table>  
			</div>
			<!-- /.panel-body -->
		</div>
		<!-- /.panel -->
	</div>
	
	<!-- /.col-lg-4 -->
</div>
<!-- /.row -->

