<?php
class Database {

	// Function to the database and tables and fill them with the default data
	function create_database($data)
	{
		// Connect to the database
		$mysqli = new mysqli($data['hostname'],$data['db_user'],$data['db_password'],'');

		// Check for errors
		if(mysqli_connect_errno())
			return false;

		// Create the prepared statement
		$mysqli->query("CREATE DATABASE IF NOT EXISTS ".$data['db_name']);

		// Close the connection
		$mysqli->close();

		return true;
	}

	// Function to create the tables and fill them with the default data
	function create_tables($data)
	{
		// Connect to the database
		$mysqli = new mysqli($data['hostname'],$data['db_user'],$data['db_password'],$data['db_name']);

		// Check for errors
		if(mysqli_connect_errno()){
			echo "Failed to connect to MySQL: " . mysqli_connect_error();
			return false;
		}

		// Open the default SQL file
		$query = file_get_contents('assets/install.sql');

		// Execute a multi query
		if($mysqli->multi_query($query)){
			while ($mysqli->next_result()) {;}
			$this->save_company_details($data);
			$this->save_admin_details($data);
		}

		// Close the connection
		$mysqli->close();

		return true;
	}

	function save_company_details($data)
	{
		$company_name 	= $data['company_name'];
		$timezone 		= $data['timezone'];
		
		// Connect to the database	
		$mysqli = new mysqli($data['hostname'],$data['db_user'],$data['db_password'],$data['db_name']);
		
		if(mysqli_connect_errno()){
			echo "Failed to connect to MySQL: " . mysqli_connect_error();
			exit;
			return false;
		}
		// Create the prepared statement
		$table = 'config';
		$qry = "INSERT INTO ".$table." (company_name, timezone) VALUES ('$company_name', '$timezone')";
	
		$mysqli->query($qry) or die($mysqli->error); 

		// Close the connection
		$mysqli->close();
	
	}

	function save_admin_details($data) 
	{
		$now 		= date('Y-m-d H:i:s');
		$firstname 	= 'admin';
		$email 		= $data['admin_email'];
		$password 	= $this->hash($data['admin_password']);
		$user_group = '1';
		$created 	= $now;
		$modified 	= $now;

		// Connect to the database
		$mysqli = new mysqli($data['hostname'],$data['db_user'],$data['db_password'],$data['db_name']);
		
		if(mysqli_connect_errno()){
			echo "Failed to connect to MySQL: " . mysqli_connect_error();
			exit;
			return false;
		}
		
		// Create the prepared statement
		
		$table = 'users';
		$qry = "INSERT INTO ".$table." (firstname, email, password, user_group, created, modified) VALUES ('$firstname', '$email', '$password', '$user_group', '$created', '$modified')";
		
		$mysqli->query($qry);

		// Close the connection
		$mysqli->close();
	
	}
	
	public function hash($string)
	{
		return hash('sha512', $string.'dfmvbrtytr453454fdg546dfdf67sdf123oip213');
	}
}