<?php
error_reporting(0); //Setting this to E_ALL showed that that cause of not redirecting were few blank lines added in some php files.
$db_config_path = '../application/config/database.php';

// Only load the classes in case the user submitted the form
if($_POST) {

	// Load the classes and create the new objects
	require_once('includes/core_class.php');
	require_once('includes/database_class.php');

	$core = new Core();
	$database = new Database();

	// Validate the post data
	if($core->validate_post($_POST) == true)
	{
		// First create the database, then create tables, then write config file
		if($database->create_database($_POST) == false) {
			$message = $core->show_message('error',"The database could not be created, please verify your settings.");
		} else if ($database->create_tables($_POST) == false) {
			$message = $core->show_message('error',"The database tables could not be created, please verify your settings.");
		} else if ($core->write_config($_POST) == false) {
			$message = $core->show_message('error',"The database configuration file could not be written, please chmod application/config/database.php file to 777");
		} else if($core->write_index_file($_POST['timezone']) == false){
			$message = $core->show_message('error',"The index timezone file could not be added, please chmod index.php file to 777");
		} else if($core->write_site_name($_POST['company_name']) == false){
			$message = $core->show_message('error',"The site name, please chmod config/invotim_config.php file to 777");
		}

		// If no errors, redirect to login page
		if(!isset($message)) {
		  $redir = ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") ? "https" : "http");
      $redir .= "://".$_SERVER['HTTP_HOST'];
      $redir .= str_replace(basename($_SERVER['SCRIPT_NAME']),"",$_SERVER['SCRIPT_NAME']);
      $redir = str_replace('install/','',$redir); 
			header( 'Location: ' . $redir . 'auth' ) ;
		}
	}
	else {
		$message = $core->show_message('error','Not all fields have been filled in correctly. The host, username, password, database name, company name, timezone. email and password are required.');
	}
}
require_once 'includes/functions.php';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<script src="assets/js/jquery-1.7.1.min.js"></script>
		<script src="assets/js/jquery.validate.min.js"></script>
		<script src="assets/js/script.js"></script>
		<link href="assets/css/style.css" rel="stylesheet">
		<title>Install | Invotim System</title>
	</head>
	<body>
    <?php if(is_writable($db_config_path)){?>

		  <?php if(isset($message)) {echo '<p class="error">' . $message . '</p>';}?>

		  <form id="install_form" class="smart-blue" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
		  <h1>Invotim Installation</h1>
		  <h3>Database Details</h3>
          <label for="hostname">Hostname</label><input type="text" id="hostname" value="localhost" class="input_text" name="hostname" />
          <label for="username">Database User</label><input type="text" id="db_user" value="root" class="input_text" name="db_user" />
          <label for="password">Database Password</label><input type="password" id="db_password" class="input_text" name="db_password" />
          <label for="database">Database Name</label><input type="text" id="db_name" class="input_text" name="db_name" />
		  <h3>Company Details</h3>
		  <label for="hostname">Company Name</label><input type="text" id="company_name" class="input_text" name="company_name" />
		  <label><span>Timezone</span>
		  <?php $timezones = timezone_select(); ?>
		  <select name="timezone" id="timezone">
		  <option value="">Select Timezone</option>
		  <?php foreach ($timezones as $key=>$timezone) : ?>
		  <option value="<?php echo $key; ?>"><?php echo $timezone; ?></option>
		  <?php endforeach; ?>
		  </select>
			
		  </label>
		  <h3>Administrator Account</h3>
		  <label for="admin_email">Email</label><input type="text" id="admin_email" class="input_text" name="admin_email" />
          <label for="admin_password">Password</label><input type="password" id="admin_password" class="input_text" name="admin_password" />
          <input type="submit" value="Install" class="button" id="submit" style="float:right"/>
          <div class="clr"></div>
		  </form>

	  <?php } else { ?>
      <p class="error">Please make the application/config/database.php file writable. <strong>Example</strong>:<br /><br /><code>chmod 777 application/config/database.php</code></p>
	  <?php } ?>	  
	</body>
</html>