$(function() {
    $('#side-menu').metisMenu();
    $('.selectpicker').selectpicker();
    window.setTimeout(function() { $(".alert-dismissable").hide('slow'); }, 2000);
    
    $('[data-toggle="tooltip"]').tooltip({
        'placement': 'top'
    });
    
    	var timer = '';
		$.post(base_url + 'timer/get_active_timer', {}, function(timer_response){
		var response = JSON.parse(timer_response);
		if (response.has_timer) 
		{
			timer_offset = response.timer_offset;
			timer = $('.timer-clock').timer({startVal : timer_offset});
			timer.startTimer();
			$('#nav-top-timer').show();
			button = '<button class="btn btn-block btn-danger countdown-timer btn-circle btn-lg" id="stop-timer" data-toggle="tooltip"><span class="glyphicon glyphicon-stop"></span></button>';
			$('#topnav_project_name').html('<strong> Project : </strong>' + response.project_name);
			$('.start-stop-div').html(button);
			$('#selected_project').val(response.project);
			$('#project_task').val(response.task);
			$('.selectpicker').selectpicker('refresh');
			$('#selected_project').attr('disabled', 'disabled');
			$('#project_task').attr('disabled', 'disabled');
		}
		else 
		{
			timer = $('.timer-clock').timer();
		}
		});	
		
		$(document).on('click', '.delete_item', function(e){
			e.preventDefault();
			$(this).closest("tr").remove();
			claculate_invoice_amount();
		});
	
	//Display open project select in order to create an invoice
		$(document).on('click', '#show_open_projects', function (e){
			e.preventDefault();
			if(!$('#open_projects_well').is(':visible')){
				$('#create-invoice-form').hide();
				$('#open_projects_well').show();
				$('#open_projects_select').val('');
				$('.selectpicker').selectpicker('refresh');
			}
		});
		
	//cancel invoice
		$(document).on('click', '#btn-close-invoice-form', function(e){
			e.preventDefault();
			if(!$('#open_projects_well').is(':visible')){
				$('#create-invoice-form').hide();
				$('#open_projects_well').show();
				$('#open_projects_select').val('');
				$('.selectpicker').selectpicker('refresh');
			}
		});
		
	//hide open projects select 
		
		$(document).on('click', '#close_open_projects_well', function (e){
			e.preventDefault();
			if($('#open_projects_well').is(':visible')){
				$('#open_projects_well').hide();
			}
		});
		
	// Display new invoice form
		$(document).on('change', '#open_projects_select', function (e){
			e.preventDefault();
			$('.overlay-wrap').show();
			var project = $('#open_projects_select').val();
			$.post(base_url + 'billing/invoice_template', {project : project}, function(data){
			var response = JSON.parse(data);
			if (response.success) 
			{
				$('#create-invoice-form').html(response.template);
				$('#open_projects_well').hide();
				$('#create-invoice-form').show();
				$('.overlay-wrap').hide();
			}
			else{
				$('.overlay-wrap').hide();
				alert (response.error);
			}
		});
		});
		
	//Add an invoice item row
		$(document).on('click', '#bttn_add_item', function() 
		{
			$('#new_item').clone().appendTo('#item_table').removeAttr('id').addClass('item').show();
		});
		
	//Start / stop timer	
		
    $(document).on('click', '.countdown-timer', function(e) {
    	id = $(this).attr('id');
        e.preventDefault();
        $('.error').remove();
    	var project = $('#selected_project').val();
    	var task = $('#project_task').val();
    	if(project == '')
		{
    		$('#selected_project').after('<div class="error">Select a project first</div>'); 
		}
    	else if(task == '')
		{
    		$('#project_task').after('<div class="error">Enter a task first</div>'); 
		}
    	else
		{
    		toggle_timer(timer, id);
		}
     });
    
    $(".btn-save").click(function(e){
    	 e.preventDefault();
        var form = $(this).parents('form:first');
        submit_form (form);
    }); 
    
    // Ajax pagination function
    
	$('#page-wrapper').on('click', '.ajax_paging', function(e)
	 {
	  $('.overlay-wrap').show();
	  $.ajax({
	  type: "GET",
	  url: $(this).get(),
	  success: function(html) {
	   $('#page-wrapper').html(html);
	   $('.overlay-wrap').hide();
	  }
	  });
	  return false;
	});  
	
});

// A function to submit the form via ajax

function submit_form(form)
{
	$('.overlay-wrap').show();
	var action_url = form.attr('action');
	var formData =  new FormData(form[0]);
	  
	   $.ajax({
		    url: action_url,
		    type: 'POST',
		    data: formData,
		    async: false,
		    cache: false,
		    contentType: false,
		    processData: false,
		    success: function (data) {
		    	var response = JSON.parse(data);
                if (response.success == '1')
                {
                    // The validation was successful, redirect user
                    window.location.reload(true);
                }
                else
                {
                    // The validation was not successful
                    $('.form-group').removeClass('has-error');
                    $('.error').remove();
                    for (var key in response.validation_errors) {
                        $('#' + key).parent().addClass('has-error');
                        $('#' + key).after('<div class="error">' +response.validation_errors[key]+ '</div>');
                    }
                    
                    if(response.invalid_upload){
                    	 $('#profile_pic_name').parent().addClass('has-error');
                    	 $('#profile_pic_name').after('<div class="error">' +response.upload_error+ '</div>');
                    	 
                    	 if(response.invoice_logo_fail_error != ''){
                    		 $('#invoice_logo').parent().parent().addClass('has-error');
                        	 $('#invoice_logo').after('<div class="error">' +response.invoice_logo_fail_error+ '</div>');
                    	 }
                    	 if(response.company_logo_fail_error != ''){
                    		 $('#company_logo').parent().parent().addClass('has-error');
                        	 $('#company_logo').after('<div class="error">' +response.company_logo_fail_error+ '</div>');
                    	 }
                    }
                }
                $('.overlay-wrap').hide();
		    }
		  });
	  
	  return false;  
}

function toggle_timer(timer, id)
{
	
	if(id == 'start-timer')
	{
		var project = $('#selected_project').val();
		var project_task = $('#project_task').val();
		$.post(base_url + 'timer/save', {project : project, start_timer : 'true', task : project_task}, function(timer_response){
			var response = JSON.parse(timer_response);
			if (response.success) 
			{
				timer.startTimer();
				button = '';
				$('#selected_project').attr('disabled', 'disabled');
				$('#project_task').attr('disabled', 'disabled');
				$('#selected_project').val(response.project);
				button = '<button class="btn btn-block btn-danger btn-circle countdown-timer btn-lg" id="stop-timer" data-toggle="tooltip"><span class="glyphicon glyphicon-stop"></span></button>';
				$('#nav-top-timer').show();
				$('#topnav_project_name').html('Project : ' + response.project_name);
				$('.start-stop-div').html(button);
			}
			else {
				alert(response.error);
			}
		});		
	}
	else 
	{
		$.post(base_url + 'timer/save', {project : project, start_timer : 'false', task : project_task}, function(timer_response){
			var response = JSON.parse(timer_response);
			if (response.success) 
			{
				
				button = '';
				$('#selected_project').removeAttr('disabled');
				$('#project_task').removeAttr('disabled');
				$('#selected_project').val('');
				$('#project_task').val('');
				$('.selectpicker').selectpicker('refresh');
				button = '<button class="btn btn-block btn-success btn-circle countdown-timer btn-lg" id="start-timer" data-toggle="tooltip"><span class="glyphicon glyphicon-play"></span></button>';
				$('#nav-top-timer').hide();
				$('.start-stop-div').html(button);
				timer.resetTimer();
				window.location.reload(true);
			}
			else {
				alert(response.error);
			}
		});	
	}
	
}
function claculate_invoice_amount(){
	var invoice_subtotal = parseFloat(0);
	var invoice_tax_total = parseFloat(0);
	var invoice_total_amount = parseFloat(0);
	$('table tr.item').each(function() {
		var item_subtotal 	= $(this).find("input[name=item_subtotal]").val();
		var item_tax 		= $(this).find("select[name=item_tax]").val();
		invoice_tax_total 	= invoice_tax_total + ((item_subtotal * item_tax) / 100);
		invoice_subtotal 	= invoice_subtotal + parseFloat(item_subtotal);
	});
	invoice_total_amount = parseFloat(invoice_subtotal + invoice_tax_total).toFixed(2);
	
	$('#invoice_subtotal').val(invoice_subtotal.toFixed(2));
	$('#tax_total').val(invoice_tax_total.toFixed(2));
	$('#invoice_total_amount').val(invoice_total_amount);
}
function previewInvoice() {
	$('.overlay-wrap').show();
	
		if($('#create-invoice-form').is(':visible')){
			project_id 	= $('#project_id').val();
			invoice_id 	= $('#invoice_id').val();
		var items = [];
		$('table tr.item').each(function() {
			var row = {};
			$(this).find('input,select,textarea').each(function() 
			{
				row[$(this).attr('name')] = $(this).val();
			});
			items.push(row);
		});	
		
		$.post(base_url + 'billing/previewinvoice', { invoice_id : invoice_id , project : project_id, invoice_items : JSON.stringify(items) }, function(ajax_response){
		var response = JSON.parse(ajax_response);
		
			if($('#create-invoice-form').is(':visible')){
				$('#create-invoice-form').hide();
				$('#create_invoice_btn').hide();
				$('#preview_body').html(response.preview);
				$('#preview-invoice').show();
				$('.overlay-wrap').hide();
			}
	});
	}
	else {
		$('#create-invoice-form').show();
		$('#create_invoice_btn').show();
		$('#preview_body').html('');
		$('#preview-invoice').hide();
		$('.overlay-wrap').hide();
	}
}

function create_invoice(draft){
		$('.overlay-wrap').show();
		save_type 	= (draft) ? 'draft' : 'new';
		client_id 	= $('#client_id').val();
		project_id 	= $('#project_id').val();
		
		var items = [];
		$('table tr.item').each(function() {
			var row = {};
			$(this).find('input,select,textarea').each(function() 
			{
				row[$(this).attr('name')] = $(this).val();
			});
			items.push(row);
		});	
		if(items.length > 0) {
		$.post(base_url + 'billing/create_invoice', { save_type : save_type, project_id : project_id, client_id : client_id, invoice_items : JSON.stringify(items) }, function(ajax_response){
			var response = JSON.parse(ajax_response);
				if(response.success){
					window.location = base_url + 'billing';
				}
		});
		}else{
			$('.overlay-wrap').hide();
		}
}

// function to update an edited invoice
function edit_invoice(){
	invoice_id 	= $('#invoice_id').val();
	
	var items = [];
	$('table tr.item').each(function() {
		var row = {};
		$(this).find('input,select,textarea').each(function() 
		{
			row[$(this).attr('name')] = $(this).val();
		});
		items.push(row);
	});	
	if(items.length > 0) {
	$.post(base_url + 'billing/edit/' + invoice_id, { invoice_id : invoice_id, invoice_items : JSON.stringify(items) }, function(ajax_response){
		var response = JSON.parse(ajax_response);
			if(response.success){
				window.location = base_url + 'billing';
			}
	});
	}
}

// function to delete invoice item

function delete_item(invoice_id, item_id){
	window.location = base_url + 'billing';
}

//function to auto search table using jQuery
$("#searchInput").keyup(function () {
    //split the current value of searchInput
    var data = this.value.split(" ");
    //create a jquery object of the rows
    var jo = $("#fbody").find("tr");
    if (this.value == "") {
        jo.show();
        return;
    }
    //hide all the rows
    jo.hide();

    //Recusively filter the jquery object to get results.
    jo.filter(function (i, v) {
        var $t = $(this);
        for (var d = 0; d < data.length; ++d) {
            if ($t.is(":contains('" + data[d] + "')")) {
                return true;
            }
        }
        return false;
    });
});



$(document).ready(function(){
    var notification_count = '0';
    function messageNotifications(){
        $.ajax({
          url:base_url + "notifications",
          type:"POST",
          data:{  'notification_count' : notification_count },
          success:function(response){                 
            var result = $.parseJSON(response);
            if(result.success == true){
                if(result.notification_count > 0)
                {
                  $('#notifications_badge').html(result.notification_count);
                  $('#notification_dropdown').html(result.data);
                }
                else
                {
                  $('#notification_dropdown').html('<li><a href="javascript: void(0);"><div><strong> No notifications available </strong></div></a></li>');
                  $('#notifications_badge').html('');
                }    
            }
          }
      });
    }
    messageNotifications();
    setInterval( function(){messageNotifications()} , 5000);
  });

$(document).on('click', '.view_notification', function (e){
	e.preventDefault();
	var notification_id = $(this).attr('alt');
	var action_url = $(this).attr('href');
	   $.ajax({
	          url:base_url + "notifications/mark_as_read",
	          type:"POST",
	          data:{  'notification_id' : notification_id },
	          success:function(response){                 
	            var result = $.parseJSON(response);
	            if(result.success == true){
	            	window.location.href = action_url;
	            }
	          }
	      });
});
$(document).on('click', '.btn-delete', function (e){ confirm_dialog($(this).attr('href')); return false; });
function confirm_dialog(action_url){
    BootstrapDialog.show({
    	title: 'Deleting a Record',
        message: 'You are about to delete a record. This action cannot be undone. Are you sure?',
        buttons: [ {
            icon: 'glyphicon glyphicon-ok',
            label: ' Yes',
            cssClass: 'btn-success btn-sm',
            action: function(){
            	window.location.href = action_url;
            },
        }, {
        	icon: 'glyphicon glyphicon-remove',
            label: 'No',
            cssClass: 'btn-danger btn-sm',
            action: function(dialogItself){
                dialogItself.close();
            },
        }]
    });
    return false;
}


